This is a patch to go from libwin32 v0.171 to v0.172.  This is yet another
unofficial patch that corresponds to the libwin32 that ships with ActivePerl
build 626.  Apply using GNU patch as follows:

    # get libwin32-0.16.zip, libwin32-0.171.patch, libwin32-0.172.patch first
    unzip libwin32-0.16.zip
    rename libwin32-0.16 libwin32-0.172
    cd libwin32-0.172
    patch -p1 -N < ../libwin32-0.171.patch
    patch -p1 -N < ../libwin32-0.172.patch

Note that the patch for v0.171 must be applied first.

Enjoy.

Gurusamy Sarathy
gsar@ActiveState.com
------------------------------------8<------------------------------------
diff -urN libwin32-0.171/APIFile/File.pm libwin32-0.172/APIFile/File.pm
--- libwin32-0.171/APIFile/File.pm	Mon May 14 00:12:25 2001
+++ libwin32-0.172/APIFile/File.pm	Mon May 14 00:14:07 2001
@@ -839,7 +839,7 @@
 
 C<$sOldFileName> is the path to the file to be copied. 
 C<$sNewFileName> is the path to where the file should be copied. 
-Note that you can E<NOT> just specify a path to a directory in
+Note that you can B<NOT> just specify a path to a directory in
 C<$sNewFileName> to copy the file to that directory using the
 same file name.
 
@@ -907,8 +907,8 @@
 Locking this for exclusive access doesn't prevent access to the
 physical drive that the partition is on so other processes can
 still access the raw sectors that way.  Locking this for exclusive
-access E<does> prevent other processes from opening the same raw
-partition and E<does> prevent access to the file system on it.  It
+access B<does> prevent other processes from opening the same raw
+partition and B<does> prevent access to the file system on it.  It
 even prevents the current process from accessing the file system
 on that partition.
 
@@ -1043,7 +1043,7 @@
 =item C<DeleteFile( $sFileName )>
 
 Deletes the named file.  Compared to Perl's C<unlink>, C<DeleteFile>
-has the advantage of not deleting read-only files.  For E<some>
+has the advantage of not deleting read-only files.  For B<some>
 versions of Perl, C<unlink> silently calls C<chmod> whether it needs
 to or not before deleting the file so that files that you have
 protected by marking them as read-only are not always protected from
@@ -1540,7 +1540,7 @@
 a sample of this format].
 
 C<$lTargetBuf> is the size [in bytes] of the buffer to allocate for
-C<$osTargetPath>.  See L<Buffers Sizes> for more information.
+C<$osTargetPath>.  See L<Buffer Sizes> for more information.
 
 C<$olTargetLen> is set to the number of bytes written to
 C<$osTargetPath> but you can also use C<length($osTargetPath)>
@@ -1582,7 +1582,7 @@
 
 =item C<$uOldMode= SetErrorMode( $uNewMode )>
 
-Sets the mode controlling system error handling E<and> returns the
+Sets the mode controlling system error handling B<and> returns the
 previous mode value.  Both C<$uOldMode> and C<$uNewMode> will have
 zero or more of the following bits set:
 
@@ -2249,7 +2249,7 @@
 bytes] where the formatting should begin.
 
 =item C<$uLength>
-        
+
 The length [in bytes] of the section to be formatted.
 
 =back
diff -urN libwin32-0.171/APINet/Changes libwin32-0.172/APINet/Changes
--- libwin32-0.171/APINet/Changes	Mon May 14 00:12:25 2001
+++ libwin32-0.172/APINet/Changes	Mon May 14 00:14:07 2001
@@ -1,5 +1,10 @@
 Revision history for Perl extension Win32API::Net
 
+0.09	Tue Sep 05 2000
+	- fixed yet another memory leak pointed out again by Eamon Doyle.
+	  Macro HV_STORE_AV used newRV_inc instead of newRV_noinc
+	- Corrected minor typo in documentation
+
 0.081   Mon May 22 20:38:11 2000
         - support for building under Perl v5.6.0.
 	- fixed a leak due to improper freeing in UserGetInfo()
diff -urN libwin32-0.171/APINet/Net.html libwin32-0.172/APINet/Net.html
--- libwin32-0.171/APINet/Net.html	Mon May 14 00:12:25 2001
+++ libwin32-0.172/APINet/Net.html	Mon May 14 00:14:08 2001
@@ -6,1749 +6,1558 @@
 
 <BODY>
 
+<A NAME="__index__"></A>
 <!-- INDEX BEGIN -->
 
 <UL>
 
-	<LI><A HREF="#NAME">NAME</A>
-	<LI><A HREF="#SYNOPSIS">SYNOPSIS</A>
-	<LI><A HREF="#NOTE_ON_VERSIONS_PRIOR_TO_0_08">NOTE ON VERSIONS PRIOR TO 0.08</A>
-	<LI><A HREF="#DESCRIPTION">DESCRIPTION</A>
+	<LI><A HREF="#name">NAME</A></LI>
+	<LI><A HREF="#synopsis">SYNOPSIS</A></LI>
+	<LI><A HREF="#note on versions prior to 0.08">NOTE ON VERSIONS PRIOR TO 0.08</A></LI>
+	<LI><A HREF="#description">DESCRIPTION</A></LI>
 	<UL>
 
-		<LI><A HREF="#Using_References">Using References</A>
+		<LI><A HREF="#using references">Using References</A></LI>
 	</UL>
 
-	<LI><A HREF="#DATA_STRUCTURES">DATA STRUCTURES</A>
-	<LI><A HREF="#Exports">Exports</A>
-	<LI><A HREF="#NET_USER_FUNCTIONS">NET USER FUNCTIONS</A>
+	<LI><A HREF="#data structures">DATA STRUCTURES</A></LI>
+	<LI><A HREF="#exports">EXPORTS</A></LI>
+	<LI><A HREF="#net user functions">NET USER FUNCTIONS</A></LI>
 	<UL>
 
-		<LI><A HREF="#UserAdd_server_level_hash_err">UserAdd(server, level, hash, error)</A>
-		<LI><A HREF="#UserChangePassword_server_user_">UserChangePassword(server, user, old, new)</A>
-		<LI><A HREF="#UserDel_server_user_">UserDel(server, user)</A>
-		<LI><A HREF="#UserEnum_server_array_filter_">UserEnum(server, array[, filter])</A>
-		<LI><A HREF="#UserGetGroups_server_user_arra">UserGetGroups(server, user, array)</A>
-		<LI><A HREF="#UserGetInfo_server_user_level_">UserGetInfo(server, user, level, hash)</A>
-		<LI><A HREF="#UserGetLocalGroups_server_user_">UserGetLocalGroups(server, user, array[, flags])</A>
-		<LI><A HREF="#UserModalsGet_">UserModalsGet()</A>
-		<LI><A HREF="#UserModalsSet_">UserModalsSet()</A>
-		<LI><A HREF="#UserSetGroups_server_user_arra">UserSetGroups(server, user, array)</A>
-		<LI><A HREF="#UserSetInfo_server_user_level_">UserSetInfo(server, user, level, hash, error)</A>
+		<LI><A HREF="#useradd(server, level, hash, error)">UserAdd(server, level, hash, error)</A></LI>
+		<LI><A HREF="#userchangepassword(server, user, old, new)">UserChangePassword(server, user, old, new)</A></LI>
+		<LI><A HREF="#userdel(server, user)">UserDel(server, user)</A></LI>
+		<LI><A HREF="#userenum(server, array[, filter])">UserEnum(server, array[, filter])</A></LI>
+		<LI><A HREF="#usergetgroups(server, user, array)">UserGetGroups(server, user, array)</A></LI>
+		<LI><A HREF="#usergetinfo(server, user, level, hash)">UserGetInfo(server, user, level, hash)</A></LI>
+		<LI><A HREF="#usergetlocalgroups(server, user, array[, flags])">UserGetLocalGroups(server, user, array[, flags])</A></LI>
+		<LI><A HREF="#usermodalsget()"><CODE>UserModalsGet()</CODE></A></LI>
+		<LI><A HREF="#usermodalsset()"><CODE>UserModalsSet()</CODE></A></LI>
+		<LI><A HREF="#usersetgroups(server, user, array)">UserSetGroups(server, user, array)</A></LI>
+		<LI><A HREF="#usersetinfo(server, user, level, hash, error)">UserSetInfo(server, user, level, hash, error)</A></LI>
 	</UL>
 
-	<LI><A HREF="#NET_GROUP_FUNCTIONS">NET GROUP FUNCTIONS</A>
+	<LI><A HREF="#net group functions">NET GROUP FUNCTIONS</A></LI>
 	<UL>
 
-		<LI><A HREF="#GroupAdd_server_level_hash_er">GroupAdd(server, level, hash, error)</A>
-		<LI><A HREF="#GroupAddUser_server_group_user">GroupAddUser(server, group, user)</A>
-		<LI><A HREF="#GroupDel_server_group_">GroupDel(server, group)</A>
-		<LI><A HREF="#GroupDelUser_server_group_user">GroupDelUser(server, group, user)</A>
-		<LI><A HREF="#GroupEnum_server_array_">GroupEnum(server, array)</A>
-		<LI><A HREF="#GroupGetInfo_server_group_leve">GroupGetInfo(server, group, level, hash)</A>
-		<LI><A HREF="#GroupGetUsers_server_group_arr">GroupGetUsers(server, group, array)</A>
-		<LI><A HREF="#GroupSetInfo_server_group_leve">GroupSetInfo(server, group, level, hash, error)</A>
-		<LI><A HREF="#GroupSetUsers_server_group_arr">GroupSetUsers(server, group, array)</A>
+		<LI><A HREF="#groupadd(server, level, hash, error)">GroupAdd(server, level, hash, error)</A></LI>
+		<LI><A HREF="#groupadduser(server, group, user)">GroupAddUser(server, group, user)</A></LI>
+		<LI><A HREF="#groupdel(server, group)">GroupDel(server, group)</A></LI>
+		<LI><A HREF="#groupdeluser(server, group, user)">GroupDelUser(server, group, user)</A></LI>
+		<LI><A HREF="#groupenum(server, array)">GroupEnum(server, array)</A></LI>
+		<LI><A HREF="#groupgetinfo(server, group, level, hash)">GroupGetInfo(server, group, level, hash)</A></LI>
+		<LI><A HREF="#groupgetusers(server, group, array)">GroupGetUsers(server, group, array)</A></LI>
+		<LI><A HREF="#groupsetinfo(server, group, level, hash, error)">GroupSetInfo(server, group, level, hash, error)</A></LI>
+		<LI><A HREF="#groupsetusers(server, group, array)">GroupSetUsers(server, group, array)</A></LI>
 	</UL>
 
-	<LI><A HREF="#NET_LOCAL_GROUP_FUNCTIONS">NET LOCAL GROUP FUNCTIONS</A>
+	<LI><A HREF="#net local group functions">NET LOCAL GROUP FUNCTIONS</A></LI>
 	<UL>
 
-		<LI><A HREF="#LocalGroupAdd_server_level_has">LocalGroupAdd(server, level, hash, error)</A>
-		<LI><A HREF="#LocalGroupAddMember_">LocalGroupAddMember()</A>
-		<LI><A HREF="#LocalGroupAddMembers_server_gro">LocalGroupAddMembers(server, group, array)</A>
-		<LI><A HREF="#LocalGroupDel_server_group_">LocalGroupDel(server, group)</A>
-		<LI><A HREF="#LocalGroupDelMember_">LocalGroupDelMember()</A>
-		<LI><A HREF="#LocalGroupDelMembers_server_gro">LocalGroupDelMembers(server, group, array)</A>
-		<LI><A HREF="#LocalGroupEnum_server_array_">LocalGroupEnum(server, array)</A>
-		<LI><A HREF="#LocalGroupGetInfo_server_group_">LocalGroupGetInfo(server, group, level, hash)</A>
-		<LI><A HREF="#LocalGroupGetMembers_server_gro">LocalGroupGetMembers(server, group, hash)</A>
-		<LI><A HREF="#LocalGroupSetInfo_server_level_">LocalGroupSetInfo(server, level, hash, error)</A>
-		<LI><A HREF="#LocalGroupSetMembers_">LocalGroupSetMembers()</A>
+		<LI><A HREF="#localgroupadd(server, level, hash, error)">LocalGroupAdd(server, level, hash, error)</A></LI>
+		<LI><A HREF="#localgroupaddmember()"><CODE>LocalGroupAddMember()</CODE></A></LI>
+		<LI><A HREF="#localgroupaddmembers(server, group, array)">LocalGroupAddMembers(server, group, array)</A></LI>
+		<LI><A HREF="#localgroupdel(server, group)">LocalGroupDel(server, group)</A></LI>
+		<LI><A HREF="#localgroupdelmember()"><CODE>LocalGroupDelMember()</CODE></A></LI>
+		<LI><A HREF="#localgroupdelmembers(server, group, array)">LocalGroupDelMembers(server, group, array)</A></LI>
+		<LI><A HREF="#localgroupenum(server, array)">LocalGroupEnum(server, array)</A></LI>
+		<LI><A HREF="#localgroupgetinfo(server, group, level, hash)">LocalGroupGetInfo(server, group, level, hash)</A></LI>
+		<LI><A HREF="#localgroupgetmembers(server, group, hash)">LocalGroupGetMembers(server, group, hash)</A></LI>
+		<LI><A HREF="#localgroupsetinfo(server, level, hash, error)">LocalGroupSetInfo(server, level, hash, error)</A></LI>
+		<LI><A HREF="#localgroupsetmembers()"><CODE>LocalGroupSetMembers()</CODE></A></LI>
 	</UL>
 
-	<LI><A HREF="#NET_GET_FUNCTIONS">NET GET FUNCTIONS</A>
+	<LI><A HREF="#net get functions">NET GET FUNCTIONS</A></LI>
 	<UL>
 
-		<LI><A HREF="#GetDCName_server_domain_domain">GetDCName(server, domain, domain-controller)</A>
+		<LI><A HREF="#getdcname(server, domain, domaincontroller)">GetDCName(server, domain, domain-controller)</A></LI>
 	</UL>
 
-	<LI><A HREF="#USER_INFO_LEVELS">USER INFO LEVELS</A>
-	<LI><A HREF="#USER_INFO_FIELDS">USER INFO FIELDS</A>
-	<LI><A HREF="#USER_FLAGS">USER FLAGS</A>
-	<LI><A HREF="#USER_PRIVILEGE_FLAGS">USER PRIVILEGE FLAGS</A>
-	<LI><A HREF="#USER_ENUM_FILTER">USER ENUM FILTER</A>
-	<LI><A HREF="#USER_FIELD_ERRORS">USER FIELD ERRORS</A>
-	<LI><A HREF="#GROUP_INFO_LEVELS">GROUP INFO LEVELS</A>
-	<LI><A HREF="#GROUP_INFO_FIELDS">GROUP INFO FIELDS</A>
-	<LI><A HREF="#GROUP_FIELD_ERRORS">GROUP FIELD ERRORS</A>
-	<LI><A HREF="#GROUP_USERS_INFO_LEVELS">GROUP USERS INFO LEVELS</A>
-	<LI><A HREF="#GROUP_USERS_INFO_FIELDS">GROUP USERS INFO FIELDS</A>
-	<LI><A HREF="#LOCAL_GROUP_INFO_LEVELS">LOCAL GROUP INFO LEVELS</A>
-	<LI><A HREF="#LOCAL_GROUP_INFO_FIELDS">LOCAL GROUP INFO FIELDS</A>
-	<LI><A HREF="#LOCAL_GROUP_FIELD_ERRORS">LOCAL GROUP FIELD ERRORS</A>
-	<LI><A HREF="#EXAMPLES">EXAMPLES</A>
-	<LI><A HREF="#AUTHOR">AUTHOR</A>
-	<LI><A HREF="#SEE_ALSO">SEE ALSO</A>
-	<LI><A HREF="#ACKNOWEDGEMENTS">ACKNOWEDGEMENTS</A>
+	<LI><A HREF="#user info levels">USER INFO LEVELS</A></LI>
+	<LI><A HREF="#user info fields">USER INFO FIELDS</A></LI>
+	<LI><A HREF="#user flags">USER FLAGS</A></LI>
+	<LI><A HREF="#user privilege flags">USER PRIVILEGE FLAGS</A></LI>
+	<LI><A HREF="#user enum filter">USER ENUM FILTER</A></LI>
+	<LI><A HREF="#user field errors">USER FIELD ERRORS</A></LI>
+	<LI><A HREF="#group info levels">GROUP INFO LEVELS</A></LI>
+	<LI><A HREF="#group info fields">GROUP INFO FIELDS</A></LI>
+	<LI><A HREF="#group field errors">GROUP FIELD ERRORS</A></LI>
+	<LI><A HREF="#group users info levels">GROUP USERS INFO LEVELS</A></LI>
+	<LI><A HREF="#group users info fields">GROUP USERS INFO FIELDS</A></LI>
+	<LI><A HREF="#local group info levels">LOCAL GROUP INFO LEVELS</A></LI>
+	<LI><A HREF="#local group info fields">LOCAL GROUP INFO FIELDS</A></LI>
+	<LI><A HREF="#local group field errors">LOCAL GROUP FIELD ERRORS</A></LI>
+	<LI><A HREF="#examples">EXAMPLES</A></LI>
+	<LI><A HREF="#author">AUTHOR</A></LI>
+	<LI><A HREF="#see also">SEE ALSO</A></LI>
+	<LI><A HREF="#acknowedgements">ACKNOWEDGEMENTS</A></LI>
 </UL>
 <!-- INDEX END -->
 
 <HR>
 <P>
-<H1><A NAME="NAME">NAME</A></H1>
+<H1><A NAME="name">NAME</A></H1>
+<P>Win32API::Net - Perl interface to the Windows NT LanManager API account management functions.</P>
 <P>
-Win32API::Net - Perl interface to the Windows NT LanManager API account
-management functions.
-
-<P>
 <HR>
-<H1><A NAME="SYNOPSIS">SYNOPSIS</A></H1>
-<P>
-use Win32API::Net;
-
+<H1><A NAME="synopsis">SYNOPSIS</A></H1>
+<P>use Win32API::Net;</P>
 <P>
 <HR>
-<H1><A NAME="NOTE_ON_VERSIONS_PRIOR_TO_0_08">NOTE ON VERSIONS PRIOR TO 0.08</A></H1>
-<P>
-As of version 0.08 of this module, the behaviour relating to empty strings
+<H1><A NAME="note on versions prior to 0.08">NOTE ON VERSIONS PRIOR TO 0.08</A></H1>
+<P>As of version 0.08 of this module, the behaviour relating to empty strings
 in input hashes has changed. The old behaviour converted such strings to
 the NULL pointer. The underlying API uses this value as an indication to
 not change the value stored for a given field. This meant that you were not
-able to clear (say) the logonScript field for a user using
-<CODE>UserSetInfo().</CODE>
-
-<P>
-The new behaviour is to leave the string as an empty C string which will
+able to clear (say) the logonScript field for a user using UserSetInfo().</P>
+<P>The new behaviour is to leave the string as an empty C string which will
 allow fields to be cleared.  To pass a NULL pointer to the underlying
 API call (and thus, to leave the field as it was), you need to set the
-corresponding field to <CODE>undef</CODE>.
-
-<P>
-WARNING: <STRONG>THIS IS AN INCOMPATIBLE CHANGE</STRONG>.
-<STRONG>EXISTING SCRIPTS THAT RELIED ON PRIOR BEHAVIOR MAY NEED TO BE MODIFIED</STRONG>.
-
+corresponding field to <CODE>undef</CODE>.</P>
+<P>WARNING: <STRONG>THIS IS AN INCOMPATIBLE CHANGE</STRONG>.
+<STRONG>EXISTING SCRIPTS THAT RELIED ON PRIOR BEHAVIOR MAY NEED TO BE MODIFIED</STRONG>.</P>
 <P>
 <HR>
-<H1><A NAME="DESCRIPTION">DESCRIPTION</A></H1>
-<P>
-Win32API::Net provides a more complete wrapper for the account management
+<H1><A NAME="description">DESCRIPTION</A></H1>
+<P>Win32API::Net provides a more complete wrapper for the account management
 parts of the NT LanManager API than do other similar packages. Most of what
-you can achieve with the native C++ API is possible with this package -
-albeit in a more Perl like manner by using references to pass information
-to and from functions.
-
-<P>
-For an understanding of the environment in which these functions operate
-see
-<A HREF="#DATA_STRUCTURES">DATA STRUCTURES</A>.
-
-<P>
-The following groups of functions are available:
-
-<DL>
-<DT><STRONG><A NAME="item_NET">NET USER FUNCTIONS</A></STRONG><DD>
-<DT><STRONG>NET GROUP FUNCTIONS</STRONG><DD>
-<DT><STRONG>NET LOCAL GROUP FUNCTIONS</STRONG><DD>
-<DT><STRONG>NET GET FUNCTIONS</STRONG><DD>
-</DL>
-<P>
-All functions return 0 on failure and 1 on success. Use the
-<CODE>Win32::GetLastError()</CODE> function to find out more information on why a function failed. In
-addition, some functions that take a hash reference to pass information in
-(e.g. <CODE>UserAdd()</CODE>) have a last argument that will allow more detailed information on which
-key/value pair was not properly specified.
-
-<P>
-<HR>
-<H2><A NAME="Using_References">Using References</A></H2>
-<P>
-References to hashes and arrays are used throughout this package to pass
-information into and out of functions.
-
+you can achieve with the native C++ API is possible with this package - albeit
+in a more Perl like manner by using references to pass information to and
+from functions.</P>
+<P>For an understanding of the environment in which these functions operate see
+<A HREF="#data structures">DATA STRUCTURES</A>.</P>
+<P>The following groups of functions are available:</P>
+<DL>
+<DT><STRONG><A NAME="item_NET_USER_FUNCTIONS"><A HREF="#net user functions">NET USER FUNCTIONS</A></A></STRONG><BR>
+<DD>
+<DT><STRONG><A NAME="item_NET_GROUP_FUNCTIONS"><A HREF="#net group functions">NET GROUP FUNCTIONS</A></A></STRONG><BR>
+<DD>
+<DT><STRONG><A NAME="item_NET_LOCAL_GROUP_FUNCTIONS"><A HREF="#net local group functions">NET LOCAL GROUP FUNCTIONS</A></A></STRONG><BR>
+<DD>
+<DT><STRONG><A NAME="item_NET_GET_FUNCTIONS"><A HREF="#net get functions">NET GET FUNCTIONS</A></A></STRONG><BR>
+<DD>
+</DL>
+<P>All functions return 0 on failure and 1 on success. Use the
+<CODE>Win32::GetLastError()</CODE> function to find out more information on why a
+function failed. In addition, some functions that take a hash reference
+to pass information in (e.g. <CODE>UserAdd()</CODE>) have a last argument that will
+allow more detailed information on which key/value pair was not properly
+specified.</P>
+<P>
+<H2><A NAME="using references">Using References</A></H2>
+<P>References to hashes and arrays are used throughout this package to pass
+information into and out of functions.</P>
 <DL>
-<DT><STRONG><A NAME="item_Using">Using Hash References</A></STRONG><DD>
-<P>
+<DT><STRONG><A NAME="item_Using_Hash_References">Using Hash References</A></STRONG><BR>
+<DD>
 Where a hash reference is required you can use anything that evaluates to a
 hash reference. e.g.
-
-<P>
-<PRE>        $href = \%someHash;
-        UserAdd(server, 2, $hRef);
-</PRE>
-<P>
-Or more directly:
-
-<P>
-<PRE>        UserAdd(server, 2, \%someHash);
-</PRE>
-<DT><STRONG>Using Array references</STRONG><DD>
-<P>
+<PRE>
+        $href = \%someHash;
+        UserAdd(server, 2, $hRef);</PRE>
+<P>Or more directly:</P>
+<PRE>
+        UserAdd(server, 2, \%someHash);</PRE>
+<P></P>
+<DT><STRONG><A NAME="item_Using_Array_references">Using Array references</A></STRONG><BR>
+<DD>
 Array references are used in a similar manner to hash references. e.g.
-
-<P>
-<PRE>        $aref = \@someArray;
-        UserEnum(server, $aref);
-</PRE>
-<P>
-Or more directly:
-
-<P>
-<PRE>        UserEnum(server, \@someArray);
-</PRE>
-</DL>
-<P>
-Please note: Any <CODE>*Get*()</CODE> or <CODE>*Enum()</CODE> operation will first clear the contents of the input hash or array being
-referenced.
-
-<P>
-See <A HREF="#EXAMPLES">EXAMPLES</A> and the test.pl script for examples of usage.
-
+<PRE>
+        $aref = \@someArray;
+        UserEnum(server, $aref);</PRE>
+<P>Or more directly:</P>
+<PRE>
+        UserEnum(server, \@someArray);</PRE>
+<P></P></DL>
+<P>Please note: Any <CODE>*Get*()</CODE> or <CODE>*Enum()</CODE> operation will first clear the
+contents of the input hash or array being referenced.</P>
+<P>See <EM>EXAMPLES</EM> and the test.pl script for examples of usage.</P>
 <P>
 <HR>
-<H1><A NAME="DATA_STRUCTURES">DATA STRUCTURES</A></H1>
-<P>
-Most the the functions in the underlying API allow the programmer to pass
+<H1><A NAME="data structures">DATA STRUCTURES</A></H1>
+<P>Most the the functions in the underlying API allow the programmer to pass
 specify at runtime the amount of information that is supplied to the
-function. For example, the <CODE>NetUserGetInfo()</CODE> call allows the programmer to specify levels of 0, 1, 2, 3 (and others).
-Having specified this level, the function returns a structure that will
-contain different fields. For a level <CODE>0</CODE>, the function returns a structure that has only one field. For a supplied
-level of 1, the function returns a structure with <CODE>8</CODE> fields. The programmer needs to know in advance what fields should be
-provided or will be returned for a given level. This mechanism works very
-will since it effectively overloads functions without having to use
-different function prototypes. Perl provides better higher level data
-structures in the form of arrays and hashes. This package uses hashes as
-the means to pass these variable size structure into and out of functions.
-
-<P>
-For any function that takes a reference to a hash as input, the programmer
+function. For example, the <CODE>NetUserGetInfo()</CODE> call allows the programmer to
+specify levels of 0, 1, 2, 3 (and others). Having specified this level, the
+function returns a structure that will contain different fields. For a
+level <CODE>0</CODE>, the function returns a structure that has only one field. For a
+supplied level of 1, the function returns a structure with <CODE>8</CODE> fields. The
+programmer needs to know in advance what fields should be provided or will
+be returned for a given level. This mechanism works very will since it
+effectively overloads functions without having to use different function
+prototypes. Perl provides better higher level data structures in the form
+of arrays and hashes. This package uses hashes as the means to pass these
+variable size structure into and out of functions.</P>
+<P>For any function that takes a reference to a hash as input, the programmer
 is expected to provide appropriate keys and corresponding values as well as
 the level parameter. The called function will then takes the values out of
 the supplied hash and build the approprite structure to pass to the
-underlying API function.
-
-<P>
-For any function that takes a reference to a hash to recieve output, the
+underlying API function.</P>
+<P>For any function that takes a reference to a hash to recieve output, the
 function will first clear any keys an corresponding values in the supplied
 hash. It will call the underlying API call and will then return in the hash
-any keys and values that are applicable at the requested level.
-
-<P>
-Example:
-
-<P>
-The <CODE>UserGetInfo()</CODE> can takes a number of levels. If called with level <CODE>0</CODE>
+any keys and values that are applicable at the requested level.</P>
+<P>Example:</P>
+<P>The <CODE>UserGetInfo()</CODE> can takes a number of levels. If called with level <CODE>0</CODE>
 the supplied hash will, on return from the function, contain a single key
-and value - namely <STRONG>name</STRONG>/<STRONG>requested-users-name</STRONG>. If called with a level of <CODE>1</CODE> the supplied hash will, on return from the function, contain 8 keys and
-values. The returned keys are <CODE>name, password</CODE>, <A HREF="#item_passwordAge">passwordAge</A>,
-<A HREF="#item_priv">priv</A>, <A HREF="#item_homeDir">homeDir</A>, <A HREF="#item_comment">comment</A>, <A HREF="#item_flags">flags</A>, <A HREF="#item_scriptPath">scriptPath</A>. See
-<A HREF="#USER_INFO_FIELDS">USER INFO FIELDS</A> for more information on what these represent.
-
-<P>
-<HR>
-<H1><A NAME="Exports">Exports</A></H1>
-<P>
-By default, Win32API::Net exports no symbols into the callers namespace.
-The following tags can be used to selectively import symbols into the main
-namespace.
-
-<DL>
-<DT><STRONG><A NAME="item__User">:User</A></STRONG><DD>
-<P>
-Exports all symbols needed for the <CODE>User*()</CODE> functions. See <A HREF="#NET_USER_FUNCTIONS">NET USER FUNCTIONS</A>.
-
-<DT><STRONG><A NAME="item__Get">:Get</A></STRONG><DD>
-<P>
-Exports all symbols needed for the <CODE>Get*()</CODE> functions. See <A HREF="#NET_GET_FUNCTIONS">NET GET FUNCTIONS</A>.
-
-<DT><STRONG><A NAME="item__Group">:Group</A></STRONG><DD>
-<P>
-Exports all symbols needed for the <CODE>Group*()</CODE> functions. See <A HREF="#NET_GROUP_FUNCTIONS">NET GROUP FUNCTIONS</A>.
-
-<DT><STRONG><A NAME="item__LocalGroup">:LocalGroup</A></STRONG><DD>
-<P>
-Exports all symbols needed for the <CODE>LocalGroup*()</CODE> functions. See <A HREF="#NET_LOCAL_GROUP_FUNCTIONS">NET LOCAL GROUP FUNCTIONS</A>.
-
-</DL>
-<P>
-<HR>
-<H1><A NAME="NET_USER_FUNCTIONS">NET USER FUNCTIONS</A></H1>
-<P>
-The <CODE>User*()</CODE> functions operate on NT user accounts.
-
-<P>
-Administrator or Account Operator group membership is required to
+and value - namely <STRONG>name</STRONG>/<STRONG>requested-users-name</STRONG>. If called with a level
+of <CODE>1</CODE> the supplied hash will, on return from the function, contain 8 keys
+and values. The returned keys are <CODE>name, password</CODE>, <CODE>passwordAge</CODE>,
+<CODE>priv</CODE>, <CODE>homeDir</CODE>, <CODE>comment</CODE>, <CODE>flags</CODE>, <CODE>scriptPath</CODE>. See
+<A HREF="#user info fields">USER INFO FIELDS</A> for more information on what these represent.</P>
+<P>
+<HR>
+<H1><A NAME="exports">EXPORTS</A></H1>
+<P>By default, Win32API::Net exports no symbols into the callers namespace.
+The following tags can be used to selectively import symbols into the
+main namespace.</P>
+<DL>
+<DT><STRONG><A NAME="item_%3AUser"><CODE>:User</CODE></A></STRONG><BR>
+<DD>
+Exports all symbols needed for the <CODE>User*()</CODE> functions.
+See <A HREF="#net user functions">NET USER FUNCTIONS</A>.
+<P></P>
+<DT><STRONG><A NAME="item_%3AGet"><CODE>:Get</CODE></A></STRONG><BR>
+<DD>
+Exports all symbols needed for the <CODE>Get*()</CODE> functions.
+See <A HREF="#net get functions">NET GET FUNCTIONS</A>.
+<P></P>
+<DT><STRONG><A NAME="item_%3AGroup"><CODE>:Group</CODE></A></STRONG><BR>
+<DD>
+Exports all symbols needed for the <CODE>Group*()</CODE> functions.
+See <A HREF="#net group functions">NET GROUP FUNCTIONS</A>.
+<P></P>
+<DT><STRONG><A NAME="item_%3ALocalGroup"><CODE>:LocalGroup</CODE></A></STRONG><BR>
+<DD>
+Exports all symbols needed for the <CODE>LocalGroup*()</CODE> functions.
+See <A HREF="#net local group functions">NET LOCAL GROUP FUNCTIONS</A>.
+<P></P></DL>
+<P>
+<HR>
+<H1><A NAME="net user functions">NET USER FUNCTIONS</A></H1>
+<P>The <CODE>User*()</CODE> functions operate on NT user accounts.</P>
+<P>Administrator or Account Operator group membership is required to
 successfully execute most of these functions on a remote server or on a
 computer that has local security enabled. Administrator privileges are
-required to add an Administrator Privilege account. There are some
+required to add an Administrator Privilege account.  There are some
 exceptions to this whereby a user can change some of their own settings
 where these don't conflict with 'administrative information' (e.g. full
-name).
-
-<P>
-The <A HREF="#item_server">server</A> field can be the empty string, in which case the function defaults to
-running on the local computer. If you leave this field blank then you
-should ensure that you are running the function on a PDC or BDC for your
-current domain. Use the support function <CODE>GetDCName()</CODE> to find out what the domain controller is, should you not be running this
-on the PDC.
-
-<P>
-All functions in this section are 'DOMAIN functions'. This means that, for
-example, the <CODE>UserGetLocalGroups()</CODE> function actually lists the domain's local groups of which the named user
-is a member.
-
-<P>
-The following functions are available.
-
-<P>
-<HR>
-<H2><A NAME="UserAdd_server_level_hash_err">UserAdd(server, level, hash, error)</A></H2>
-<P>
-Add a new user account. The user name is taken from the <A HREF="#item_name">name</A>-key's value in the supplied hash.
-
+name).</P>
+<P>The <CODE>server</CODE> field can be the empty string, in which case the function
+defaults to running on the local computer. If you leave this field blank
+then you should ensure that you are running the function on a PDC or BDC
+for your current domain. Use the support function <CODE>GetDCName()</CODE> to find out
+what the domain controller is, should you not be running this on the PDC.</P>
+<P>All functions in this section are 'DOMAIN functions'. This means that,
+for example, the <CODE>UserGetLocalGroups()</CODE> function actually lists the
+domain's local groups of which the named user is a member.</P>
+<P>The following functions are available.</P>
+<P>
+<H2><A NAME="useradd(server, level, hash, error)">UserAdd(server, level, hash, error)</A></H2>
+<P>Add a new user account. The user name is taken from the <CODE>name</CODE>-key's
+value in the supplied hash.</P>
 <DL>
-<DT><STRONG><A NAME="item_server">server - Scalar String</A></STRONG><DD>
-<P>
+<DT><STRONG><A NAME="item_server_%2D_Scalar_String"><CODE>server</CODE> - Scalar String</A></STRONG><BR>
+<DD>
 The server on which to add the account.
-
-<DT><STRONG><A NAME="item_level">level - Scalar Int</A></STRONG><DD>
-<P>
-Level of information provided in hash. This can be either 1, 2 or 3. See <A HREF="#USER_INFO_LEVELS">USER INFO LEVELS</A>.
-
-<DT><STRONG><A NAME="item_hash">hash - Hash Reference</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_level_%2D_Scalar_Int"><CODE>level</CODE> - Scalar Int</A></STRONG><BR>
+<DD>
+Level of information provided in hash. This can be either 1, 2 or 3.
+See <A HREF="#user info levels">USER INFO LEVELS</A>.
+<P></P>
+<DT><STRONG><A NAME="item_hash_%2D_Hash_Reference"><CODE>hash</CODE> - Hash Reference</A></STRONG><BR>
+<DD>
 The information to use to add this account. This should have all the
-appropriate keys and values required for <A HREF="#item_level">level</A>.
-
-<DT><STRONG><A NAME="item_error">error - Scalar Int</A></STRONG><DD>
-<P>
+appropriate keys and values required for <CODE>level</CODE>.
+<P></P>
+<DT><STRONG><A NAME="item_error_%2D_Scalar_Int"><CODE>error</CODE> - Scalar Int</A></STRONG><BR>
+<DD>
 Provides information on which field in the hash was not properly specified.
-See <A HREF="#USER_FIELD_ERRORS">USER FIELD ERRORS</A> for more information about what values this can take.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="UserChangePassword_server_user_">UserChangePassword(server, user, old, new)</A></H2>
-<P>
-Changes the password for <A HREF="#item_user">user</A>. If the policy of the machine/domain only allows password changes if the <A HREF="#item_user">user</A> is logged on then the <A HREF="#item_user">user</A>
+See <A HREF="#user field errors">USER FIELD ERRORS</A> for more information about what values this can
+take.
+<P></P></DL>
+<P>
+<H2><A NAME="userchangepassword(server, user, old, new)">UserChangePassword(server, user, old, new)</A></H2>
+<P>Changes the password for <CODE>user</CODE>. If the policy of the machine/domain
+only allows password changes if the <CODE>user</CODE> is logged on then the <CODE>user</CODE>
 must be logged on to execute this function. With Administrator or Account
 Operator privilege you can use this function to change anyone's password,
-so long as you know the old password.
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> on which to change the password.
-
-<DT><STRONG><A NAME="item_user">user - Scalar String</A></STRONG><DD>
-<P>
-The name of the <A HREF="#item_user">user</A> whose password is being changed.
-
-<DT><STRONG><A NAME="item_old">old - Scalar String</A></STRONG><DD>
-<P>
-The existing password for <A HREF="#item_user">user</A>.
-
-<DT><STRONG><A NAME="item_new">new - Scalar String</A></STRONG><DD>
-<P>
-The new password for <A HREF="#item_user">user</A>.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="UserDel_server_user_">UserDel(server, user)</A></H2>
-<P>
-Deletes the specified <A HREF="#item_user">user</A> account. Administrator or Account Operator privilege is required to execute
-this function.
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> on which to delete the <A HREF="#item_user">user</A>.
-
-<DT><STRONG>user - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_user">user</A> account to delete.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="UserEnum_server_array_filter_">UserEnum(server, array[, filter])</A></H2>
-<P>
-Enumerates all the accounts on server that satisfy <A HREF="#item_filter">filter</A>. Unlike the
-<CODE>NetUserEnum()</CODE> function in the API, this function does not allow you to specify a level
-(internally it is hardcoded to 0). In Perl it is trivial to implement the
-equivalent function (should you need it) - see
-<A HREF="#Example_1">Example 1</A>.
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> on which to enumerate the accounts satisfying <A HREF="#item_filter">filter</A>.
-
-<DT><STRONG><A NAME="item_array">array - Array Reference</A></STRONG><DD>
-<P>
-The array that will hold the names of all users on <A HREF="#item_server">server</A> whose accounts match <A HREF="#item_filter">filter</A>.
-
-<DT><STRONG><A NAME="item_filter">filter - Scalar Int (optional)</A></STRONG><DD>
-<P>
-The filter to apply (see <A HREF="#USER_ENUM_FILTER">USER ENUM FILTER</A>). This argument is optional and if not present a default of <A HREF="#item_FILTER_NORMAL_ACCOUNT">FILTER_NORMAL_ACCOUNT</A> is used.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="UserGetGroups_server_user_arra">UserGetGroups(server, user, array)</A></H2>
-<P>
-Get the global groups for which <A HREF="#item_user">user</A> is a member. It returns the group names in <A HREF="#item_array">array</A>. Unlike the <CODE>NetUserGetGroups()</CODE> function in the API, this function does not allow you to specify a level
-(internally is hardcoded to 0). In Perl it is trivial to implement the
-equivalent function (in the unlikely event that you might need it).
-
+so long as you know the old password.</P>
 <DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> from which to get the groups of which <A HREF="#item_user">user</A> is a member.
-
-<DT><STRONG>user - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_user">user</A> whose group membership you wish to examine.
-
-<DT><STRONG>array - Scalar String</STRONG><DD>
-<P>
-The array that will contain the group names to which <A HREF="#item_user">user</A> belongs.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="UserGetInfo_server_user_level_">UserGetInfo(server, user, level, hash)</A></H2>
-<P>
-Returns the information at the specified <A HREF="#item_level">level</A> for the named <A HREF="#item_user">user</A>
-in <A HREF="#item_hash">hash</A>.
-
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> on which to change the password.
+<P></P>
+<DT><STRONG><A NAME="item_user_%2D_Scalar_String"><CODE>user</CODE> - Scalar String</A></STRONG><BR>
+<DD>
+The name of the <CODE>user</CODE> whose password is being changed.
+<P></P>
+<DT><STRONG><A NAME="item_old_%2D_Scalar_String"><CODE>old</CODE> - Scalar String</A></STRONG><BR>
+<DD>
+The existing password for <CODE>user</CODE>.
+<P></P>
+<DT><STRONG><A NAME="item_new_%2D_Scalar_String"><CODE>new</CODE> - Scalar String</A></STRONG><BR>
+<DD>
+The new password for <CODE>user</CODE>.
+<P></P></DL>
+<P>
+<H2><A NAME="userdel(server, user)">UserDel(server, user)</A></H2>
+<P>Deletes the specified <CODE>user</CODE> account. Administrator or Account Operator
+privilege is required to execute this function.</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> on which to delete the <CODE>user</CODE>.
+<P></P>
+<DT><STRONG><CODE>user</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>user</CODE> account to delete.
+<P></P></DL>
+<P>
+<H2><A NAME="userenum(server, array[, filter])">UserEnum(server, array[, filter])</A></H2>
+<P>Enumerates all the accounts on server that satisfy <CODE>filter</CODE>. Unlike the
+<CODE>NetUserEnum()</CODE> function in the API, this function does not allow you
+to specify a level (internally it is hardcoded to 0). In Perl it is
+trivial to implement the equivalent function (should you need it) - see
+<A HREF="#example 1">Example 1</A>.</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> on which to enumerate the accounts satisfying <CODE>filter</CODE>.
+<P></P>
+<DT><STRONG><A NAME="item_array_%2D_Array_Reference"><CODE>array</CODE> - Array Reference</A></STRONG><BR>
+<DD>
+The array that will hold the names of all users on <CODE>server</CODE> whose
+accounts match <CODE>filter</CODE>.
+<P></P>
+<DT><STRONG><A NAME="item_Int"><CODE>filter</CODE> - Scalar Int (optional)</A></STRONG><BR>
+<DD>
+The filter to apply (see <A HREF="#user enum filter">USER ENUM FILTER</A>). This argument is optional
+and if not present a default of <A HREF="#item_FILTER_NORMAL_ACCOUNT"><CODE>FILTER_NORMAL_ACCOUNT</CODE></A> is used.
+<P></P></DL>
+<P>
+<H2><A NAME="usergetgroups(server, user, array)">UserGetGroups(server, user, array)</A></H2>
+<P>Get the global groups for which <CODE>user</CODE> is a member. It returns the group
+names in <CODE>array</CODE>. Unlike the <CODE>NetUserGetGroups()</CODE> function in the API,
+this function does not allow you to specify a level (internally is
+hardcoded to 0). In Perl it is trivial to implement the equivalent function
+(in the unlikely event that you might need it).</P>
 <DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> from which to get the requested information about <A HREF="#item_user">user</A>.
-
-<DT><STRONG>user - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_user">user</A> whose information you want.
-
-<DT><STRONG>level - Scalar Int</STRONG><DD>
-<P>
-One of: 0, 1, 2, 3, 10, 11 and 20. See <A HREF="#USER_INFO_LEVELS">USER INFO LEVELS</A>.
-
-<DT><STRONG>hash - Hash Reference</STRONG><DD>
-<P>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> from which to get the groups of which <CODE>user</CODE> is a member.
+<P></P>
+<DT><STRONG><CODE>user</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>user</CODE> whose group membership you wish to examine.
+<P></P>
+<DT><STRONG><A NAME="item_array_%2D_Scalar_String"><CODE>array</CODE> - Scalar String</A></STRONG><BR>
+<DD>
+The array that will contain the group names to which <CODE>user</CODE> belongs.
+<P></P></DL>
+<P>
+<H2><A NAME="usergetinfo(server, user, level, hash)">UserGetInfo(server, user, level, hash)</A></H2>
+<P>Returns the information at the specified <CODE>level</CODE> for the named <CODE>user</CODE>
+in <CODE>hash</CODE>.</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> from which to get the requested information about <CODE>user</CODE>.
+<P></P>
+<DT><STRONG><CODE>user</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>user</CODE> whose information you want.
+<P></P>
+<DT><STRONG><CODE>level</CODE> - Scalar Int</STRONG><BR>
+<DD>
+One of: 0, 1, 2, 3, 10, 11 and 20. See <A HREF="#user info levels">USER INFO LEVELS</A>.
+<P></P>
+<DT><STRONG><CODE>hash</CODE> - Hash Reference</STRONG><BR>
+<DD>
 The hash that will contain the keys and values for the information
-requested. See <A HREF="#USER_INFO_FIELDS">USER INFO FIELDS</A> for information about which keys are present in a given level.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="UserGetLocalGroups_server_user_">UserGetLocalGroups(server, user, array[, flags])</A></H2>
-<P>
-Gets the names of the local groups of which <A HREF="#item_user">user</A> is a member. Unlike the <CODE>NetUserEnum()</CODE> function in the API, this function does not allow you to specify a level.
-Since the underlying API restricts you to level 0 there really isn't any
-need to include it...
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The server from which to get the local groups of which <A HREF="#item_user">user</A> is a member.
-
-<DT><STRONG>user - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_user">user</A> whose local group membership you wish to enumerate.
-
-<DT><STRONG>array - Array Reference</STRONG><DD>
-<P>
-The array that will hold the names of the local groups to which <A HREF="#item_user">user</A>
+requested. See <A HREF="#user info fields">USER INFO FIELDS</A> for information about which keys are
+present in a given level.
+<P></P></DL>
+<P>
+<H2><A NAME="usergetlocalgroups(server, user, array[, flags])">UserGetLocalGroups(server, user, array[, flags])</A></H2>
+<P>Gets the names of the local groups of which <CODE>user</CODE> is a member. Unlike
+the <CODE>NetUserEnum()</CODE> function in the API, this function does not allow you
+to specify a level. Since the underlying API restricts you to level 0 there
+really isn't any need to include it...</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The server from which to get the local groups of which <CODE>user</CODE> is a member.
+<P></P>
+<DT><STRONG><CODE>user</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>user</CODE> whose local group membership you wish to enumerate.
+<P></P>
+<DT><STRONG><CODE>array</CODE> - Array Reference</STRONG><BR>
+<DD>
+The array that will hold the names of the local groups to which <CODE>user</CODE>
 belongs.
-
-<DT><STRONG><A NAME="item_flags">flags - Scalar Int &lt;em&gt;(optional)&lt;/em&gt;</A></STRONG><DD>
-<P>
-Either <CODE>Win32API::Net::LG_INCLUDE_INDIRECT()</CODE> or 0. if <A HREF="#item_flags">flags</A> is omitted, the function internally uses 0. Specifying <CODE>LG_INCLUDE_INDIRECT()</CODE>
-will include in the list the names of the groups of which the <A HREF="#item_user">user</A> is indirectly a member (e.g. by being in a global group that is a member of
-a local group).
-
-<P>
-This field can take no other values.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="UserModalsGet_">UserModalsGet()</A></H2>
-<P>
-This function is not currently implemented.
-
-<P>
-<HR>
-<H2><A NAME="UserModalsSet_">UserModalsSet()</A></H2>
-<P>
-This function is not currently implemented.
-
-<P>
-<HR>
-<H2><A NAME="UserSetGroups_server_user_arra">UserSetGroups(server, user, array)</A></H2>
-<P>
-Sets the (global) group membership for <A HREF="#item_user">user</A> to the specified groups. Unlike the API function <CODE>NetUserSetGroups()</CODE>, this function does not take a
-<A HREF="#item_level">level</A> parameter (mainly because this option is largely redundant).
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> on which you wish to set the group membership for <A HREF="#item_user">user</A>.
-
-<DT><STRONG>user - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_user">user</A> whose group membership you wish to set.
-
-<DT><STRONG>array - Array Reference</STRONG><DD>
-<P>
-The array containing the (global) group names to set the <A HREF="#item_user">user</A>s membership of.
-
-</DL>
-<P>
-This function will fail if any of the group names specified do not exist.
-
-<P>
-<HR>
-<H2><A NAME="UserSetInfo_server_user_level_">UserSetInfo(server, user, level, hash, error)</A></H2>
-<P>
-Sets the info for <A HREF="#item_user">user</A> according to the information contained in <A HREF="#item_hash">hash</A>
-for <A HREF="#item_level">level</A> (see <A HREF="#USER_INFO_LEVELS">USER INFO LEVELS</A>).
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> on which you wish to change the info for <A HREF="#item_user">user</A>.
-
-<DT><STRONG>user - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_user">user</A> whose info you wish to change.
-
-<DT><STRONG>level - Scalar Int</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_flags_%2D_Scalar_Int_%3Cem%3E%28optional%29%3C%2Fe"><CODE>flags</CODE> - Scalar Int &lt;em&gt;(optional)&lt;/em&gt;</A></STRONG><BR>
+<DD>
+Either <CODE>Win32API::Net::LG_INCLUDE_INDIRECT()</CODE> or 0. if <CODE>flags</CODE> is
+omitted, the function internally uses 0. Specifying <CODE>LG_INCLUDE_INDIRECT()</CODE>
+will include in the list the names of the groups of which the <CODE>user</CODE> is
+indirectly a member (e.g. by being in a global group that is a member of a
+local group).
+<P>This field can take no other values.</P>
+<P></P></DL>
+<P>
+<H2><A NAME="usermodalsget()"><CODE>UserModalsGet()</CODE></A></H2>
+<P>This function is not currently implemented.</P>
+<P>
+<H2><A NAME="usermodalsset()"><CODE>UserModalsSet()</CODE></A></H2>
+<P>This function is not currently implemented.</P>
+<P>
+<H2><A NAME="usersetgroups(server, user, array)">UserSetGroups(server, user, array)</A></H2>
+<P>Sets the (global) group membership for <CODE>user</CODE> to the specified groups.
+Unlike the API function <CODE>NetUserSetGroups()</CODE>, this function does not take a
+<CODE>level</CODE> parameter (mainly because this option is largely redundant).</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> on which you wish to set the group membership for <CODE>user</CODE>.
+<P></P>
+<DT><STRONG><CODE>user</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>user</CODE> whose group membership you wish to set.
+<P></P>
+<DT><STRONG><CODE>array</CODE> - Array Reference</STRONG><BR>
+<DD>
+The array containing the (global) group names to set the <CODE>user</CODE>s
+membership of.
+<P></P></DL>
+<P>This function will fail if any of the group names specified do not exist.</P>
+<P>
+<H2><A NAME="usersetinfo(server, user, level, hash, error)">UserSetInfo(server, user, level, hash, error)</A></H2>
+<P>Sets the info for <CODE>user</CODE> according to the information contained in <CODE>hash</CODE>
+for <CODE>level</CODE> (see <A HREF="#user info levels">USER INFO LEVELS</A>).</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> on which you wish to change the info for <CODE>user</CODE>.
+<P></P>
+<DT><STRONG><CODE>user</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>user</CODE> whose info you wish to change.
+<P></P>
+<DT><STRONG><CODE>level</CODE> - Scalar Int</STRONG><BR>
+<DD>
 One of 0, 1, 2, 3, or 20 (according to Microsoft documentation). In
 practice, you can use all the 10xx levels as well to change most of the
-individual properties of the named <A HREF="#item_user">user</A> - although this may not be supported in future...
-
-<DT><STRONG>hash - Hash Reference</STRONG><DD>
-<P>
+individual properties of the named <CODE>user</CODE> - although this may not be
+supported in future...
+<P></P>
+<DT><STRONG><CODE>hash</CODE> - Hash Reference</STRONG><BR>
+<DD>
 The hash that will contain the necessary key/value pairs required for
-<A HREF="#item_level">level</A> (see <A HREF="#USER_INFO_LEVELS">USER INFO LEVELS</A>).
-
-<DT><STRONG>error - Scalar Int</STRONG><DD>
-<P>
-Provides information on which field in <A HREF="#item_hash">hash</A> were not properly specified. See <A HREF="#USER_FIELD_ERRORS">USER FIELD ERRORS</A> for more information about what values can be returned in this field.
-
-</DL>
-<P>
-<HR>
-<H1><A NAME="NET_GROUP_FUNCTIONS">NET GROUP FUNCTIONS</A></H1>
-<P>
-The <CODE>Group*()</CODE> functions all operate only on global groups. To modify local groups, use
-the corresponding <CODE>LocalGroup*()</CODE> functions.
-
-<P>
-Administrator or Account Operator group membership is required to
-successfully execute most of these functions on a remote server or on a
-computer that has local security enabled.
-
-<P>
-The <A HREF="#item_server">server</A> field can be the empty string, in which case the function defaults to
-running on the local computer. If you leave this field blank then you
-should ensure that you are running the function on a PDC or BDC for your
-current domain. Use the support function <CODE>GetDCName()</CODE> to find out what the domain controller is, should you not be running this
-on the PDC.
-
-<P>
-The following functions are available.
-
-<P>
-<HR>
-<H2><A NAME="GroupAdd_server_level_hash_er">GroupAdd(server, level, hash, error)</A></H2>
-<P>
-Adds the specified group.
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> on which to add the group.
-
-<DT><STRONG>level - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_level">level</A> of information contained in <A HREF="#item_hash">hash</A>. This can be one of 0, 1 or 2. See <A HREF="#GROUP_INFO_LEVELS">GROUP INFO LEVELS</A>.
-
-<DT><STRONG>hash - Hash Reference</STRONG><DD>
-<P>
-A hash containing the required key/value pairs for <A HREF="#item_level">level</A>.
-
-<DT><STRONG>error - Scalar Int</STRONG><DD>
-<P>
-Provides information on which field in <A HREF="#item_hash">hash</A> was not properly specified. See <A HREF="#GROUP_FIELD_ERRORS">GROUP FIELD ERRORS</A> for more information about what values can be returned in this field.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="GroupAddUser_server_group_user">GroupAddUser(server, group, user)</A></H2>
-<P>
-Adds the specified <A HREF="#item_user">user</A> to the specified <A HREF="#item_group">group</A>.
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> on which to add the <A HREF="#item_user">user</A> to <A HREF="#item_group">group</A>.
-
-<DT><STRONG><A NAME="item_group">group - Scalar String</A></STRONG><DD>
-<P>
-The <A HREF="#item_group">group</A> to add the <A HREF="#item_user">user</A> to.
-
-<DT><STRONG>user - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_user">user</A> to add to <A HREF="#item_group">group</A>.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="GroupDel_server_group_">GroupDel(server, group)</A></H2>
-<P>
-Deletes the specified global group.
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> on which to delete the named <A HREF="#item_group">group</A>.
-
-<DT><STRONG>group -Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_group">group</A> to delete.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="GroupDelUser_server_group_user">GroupDelUser(server, group, user)</A></H2>
-<P>
-Deletes the specified user from the specified group.
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> on which to delete <A HREF="#item_user">user</A> from <A HREF="#item_group">group</A>.
-
-<DT><STRONG>group - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_group">group</A> from which to delete <A HREF="#item_user">user</A>.
-
-<DT><STRONG>user - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_user">user</A> to delete from <A HREF="#item_group">group</A>.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="GroupEnum_server_array_">GroupEnum(server, array)</A></H2>
-<P>
-Enumerates all the global groups on the server. Unlike the API call
-<CODE>NetGroupEnum()</CODE>, this function does not allow you to specify a level (internally it is
-hardcoded to 0). In Perl it is trivial to implement the equivalent function
-(should you need it).
-
+<CODE>level</CODE> (see <A HREF="#user info levels">USER INFO LEVELS</A>).
+<P></P>
+<DT><STRONG><CODE>error</CODE> - Scalar Int</STRONG><BR>
+<DD>
+Provides information on which field in <CODE>hash</CODE> were not properly
+specified. See <A HREF="#user field errors">USER FIELD ERRORS</A> for more information about what
+values can be returned in this field.
+<P></P></DL>
+<P>
+<HR>
+<H1><A NAME="net group functions">NET GROUP FUNCTIONS</A></H1>
+<P>The <CODE>Group*()</CODE> functions all operate only on global groups. To modify
+local groups, use the corresponding <CODE>LocalGroup*()</CODE> functions.</P>
+<P>Administrator or Account Operator group membership is required to
+successfully execute most of these functions on a remote server or on
+a computer that has local security enabled.</P>
+<P>The <CODE>server</CODE> field can be the empty string, in which case the function
+defaults to running on the local computer. If you leave this field blank
+then you should ensure that you are running the function on a PDC or BDC
+for your current domain. Use the support function <CODE>GetDCName()</CODE> to find out
+what the domain controller is, should you not be running this on the PDC.</P>
+<P>The following functions are available.</P>
+<P>
+<H2><A NAME="groupadd(server, level, hash, error)">GroupAdd(server, level, hash, error)</A></H2>
+<P>Adds the specified group.</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> on which to add the group.
+<P></P>
+<DT><STRONG><A NAME="item_level_%2D_Scalar_String"><CODE>level</CODE> - Scalar String</A></STRONG><BR>
+<DD>
+The <CODE>level</CODE> of information contained in <CODE>hash</CODE>. This can be one of 0, 1
+or 2. See <A HREF="#group info levels">GROUP INFO LEVELS</A>.
+<P></P>
+<DT><STRONG><CODE>hash</CODE> - Hash Reference</STRONG><BR>
+<DD>
+A hash containing the required key/value pairs for <CODE>level</CODE>.
+<P></P>
+<DT><STRONG><CODE>error</CODE> - Scalar Int</STRONG><BR>
+<DD>
+Provides information on which field in <CODE>hash</CODE> was not properly specified.
+See <A HREF="#group field errors">GROUP FIELD ERRORS</A> for more information about what values can be
+returned in this field.
+<P></P></DL>
+<P>
+<H2><A NAME="groupadduser(server, group, user)">GroupAddUser(server, group, user)</A></H2>
+<P>Adds the specified <CODE>user</CODE> to the specified <CODE>group</CODE>.</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> on which to add the <CODE>user</CODE> to <CODE>group</CODE>.
+<P></P>
+<DT><STRONG><A NAME="item_group_%2D_Scalar_String"><CODE>group</CODE> - Scalar String</A></STRONG><BR>
+<DD>
+The <CODE>group</CODE> to add the <CODE>user</CODE> to.
+<P></P>
+<DT><STRONG><CODE>user</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>user</CODE> to add to <CODE>group</CODE>.
+<P></P></DL>
+<P>
+<H2><A NAME="groupdel(server, group)">GroupDel(server, group)</A></H2>
+<P>Deletes the specified global group.</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> on which to delete the named <CODE>group</CODE>.
+<P></P>
+<DT><STRONG><A NAME="item_group_%2DScalar_String"><CODE>group</CODE> -Scalar String</A></STRONG><BR>
+<DD>
+The <CODE>group</CODE> to delete.
+<P></P></DL>
+<P>
+<H2><A NAME="groupdeluser(server, group, user)">GroupDelUser(server, group, user)</A></H2>
+<P>Deletes the specified user from the specified group.</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> on which to delete <CODE>user</CODE> from <CODE>group</CODE>.
+<P></P>
+<DT><STRONG><CODE>group</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>group</CODE> from which to delete <CODE>user</CODE>.
+<P></P>
+<DT><STRONG><CODE>user</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>user</CODE> to delete from <CODE>group</CODE>.
+<P></P></DL>
+<P>
+<H2><A NAME="groupenum(server, array)">GroupEnum(server, array)</A></H2>
+<P>Enumerates all the global groups on the server. Unlike the API call
+<CODE>NetGroupEnum()</CODE>, this function does not allow you to specify a level
+(internally it is hardcoded to 0). In Perl it is trivial to implement
+the equivalent function (should you need it).</P>
 <DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
 The server on which to enumerate the (global) <CODE>groups</CODE>.
-
-<DT><STRONG>array - Array Reference</STRONG><DD>
-<P>
-An array that, on return, will contain the <A HREF="#item_group">group</A> names.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="GroupGetInfo_server_group_leve">GroupGetInfo(server, group, level, hash)</A></H2>
-<P>
-Retrieves <A HREF="#item_level">level</A> information for <A HREF="#item_group">group</A> returning information in
-<A HREF="#item_hash">hash</A>.
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> from which to get the group information.
-
-<DT><STRONG>group - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_group">group</A> whose information you wish to obtain.
-
-<DT><STRONG>level - Scalar Int</STRONG><DD>
-<P>
-The <A HREF="#item_level">level</A> of information you wish to retrieve. This can be one of 1, 2 or 3. See <A HREF="#GROUP_INFO_LEVELS">GROUP INFO LEVELS</A>.
-
-<DT><STRONG>hash - Hash Reference</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><CODE>array</CODE> - Array Reference</STRONG><BR>
+<DD>
+An array that, on return, will contain the <CODE>group</CODE> names.
+<P></P></DL>
+<P>
+<H2><A NAME="groupgetinfo(server, group, level, hash)">GroupGetInfo(server, group, level, hash)</A></H2>
+<P>Retrieves <CODE>level</CODE> information for <CODE>group</CODE> returning information in
+<CODE>hash</CODE>.</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> from which to get the group information.
+<P></P>
+<DT><STRONG><CODE>group</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>group</CODE> whose information you wish to obtain.
+<P></P>
+<DT><STRONG><CODE>level</CODE> - Scalar Int</STRONG><BR>
+<DD>
+The <CODE>level</CODE> of information you wish to retrieve. This can be one of 1, 2
+or 3. See <A HREF="#group info levels">GROUP INFO LEVELS</A>.
+<P></P>
+<DT><STRONG><CODE>hash</CODE> - Hash Reference</STRONG><BR>
+<DD>
 The hash that will contain the information.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="GroupGetUsers_server_group_arr">GroupGetUsers(server, group, array)</A></H2>
-<P>
-Returns (in <A HREF="#item_array">array</A>) the users belonging to <A HREF="#item_group">group</A>. Unlike the API call <CODE>NetGroupGetUsers()</CODE>, this function does not allow you to specify a level (internally it is
-hardcoded to 0). In Perl it is trivial to implement the equivalent function
-(should you need it).
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> from which to get the group information.
-
-<DT><STRONG>group - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_group">group</A> whose users you wish to obtain.
-
-<DT><STRONG>array - Array Reference</STRONG><DD>
+<P></P></DL>
 <P>
+<H2><A NAME="groupgetusers(server, group, array)">GroupGetUsers(server, group, array)</A></H2>
+<P>Returns (in <CODE>array</CODE>) the users belonging to <CODE>group</CODE>. Unlike the API
+call <CODE>NetGroupGetUsers()</CODE>, this function does not allow you to specify
+a level (internally it is hardcoded to 0). In Perl it is trivial to
+implement the equivalent function (should you need it).</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> from which to get the group information.
+<P></P>
+<DT><STRONG><CODE>group</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>group</CODE> whose users you wish to obtain.
+<P></P>
+<DT><STRONG><CODE>array</CODE> - Array Reference</STRONG><BR>
+<DD>
 The array to hold the user names retrieved.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="GroupSetInfo_server_group_leve">GroupSetInfo(server, group, level, hash, error)</A></H2>
-<P>
-Sets the information for <A HREF="#item_group">group</A> according to <A HREF="#item_level">level</A>.
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> on which to set the <A HREF="#item_group">group</A> information.
-
-<DT><STRONG>group - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_group">group</A> whose information you wish to set.
-
-<DT><STRONG>level - Scalar Int</STRONG><DD>
-<P>
-The <A HREF="#item_level">level</A> of information you are supplying in <A HREF="#item_hash">hash</A>. Level can be one of 0, 1 or 2. See <A HREF="#GROUP_INFO_LEVELS">GROUP INFO LEVELS</A>.
-
-<DT><STRONG>hash - Hash Reference</STRONG><DD>
+<P></P></DL>
 <P>
-The hash containing the required key/value pairs for <A HREF="#item_level">level</A>.
-
-<DT><STRONG>error - Scalar String</STRONG><DD>
-<P>
-On failure, the <A HREF="#item_error">error</A> parameter will contain a value which specifies which field caused the
-error. See <A HREF="#GROUP_FIELD_ERRORS">GROUP FIELD ERRORS</A>.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="GroupSetUsers_server_group_arr">GroupSetUsers(server, group, array)</A></H2>
-<P>
-Sets the membership of <A HREF="#item_group">group</A> to contain only those users specified in <A HREF="#item_array">array</A>. This function will fail if any user names contained in the array are not
-valid users on <A HREF="#item_server">server</A>. On successful completion
-<A HREF="#item_group">group</A> will contain only the users specified in <A HREF="#item_array">array</A>. Use the functions <CODE>GroupAddUser()/GroupDelUser()</CODE> to add and delete individual users from a group.
-
+<H2><A NAME="groupsetinfo(server, group, level, hash, error)">GroupSetInfo(server, group, level, hash, error)</A></H2>
+<P>Sets the information for <CODE>group</CODE> according to <CODE>level</CODE>.</P>
 <DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> on which to set the <A HREF="#item_group">group</A> membership.
-
-<DT><STRONG>group - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_group">group</A> to set the membership of.
-
-<DT><STRONG>array - Array Reference</STRONG><DD>
-<P>
-The array containing the names of all users who will be members of <A HREF="#item_group">group</A>.
-
-</DL>
-<P>
-<HR>
-<H1><A NAME="NET_LOCAL_GROUP_FUNCTIONS">NET LOCAL GROUP FUNCTIONS</A></H1>
-<P>
-The <CODE>LocalGroup*()</CODE> functions operate on local groups. If these functions are run on a PDC then
-these functions operate on the domains local groups.
-
-<P>
-Administrator or Account Operator group membership is required to
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> on which to set the <CODE>group</CODE> information.
+<P></P>
+<DT><STRONG><CODE>group</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>group</CODE> whose information you wish to set.
+<P></P>
+<DT><STRONG><CODE>level</CODE> - Scalar Int</STRONG><BR>
+<DD>
+The <CODE>level</CODE> of information you are supplying in <CODE>hash</CODE>.  Level can be
+one of 0, 1 or 2. See <A HREF="#group info levels">GROUP INFO LEVELS</A>.
+<P></P>
+<DT><STRONG><CODE>hash</CODE> - Hash Reference</STRONG><BR>
+<DD>
+The hash containing the required key/value pairs for <CODE>level</CODE>.
+<P></P>
+<DT><STRONG><A NAME="item_error_%2D_Scalar_String"><CODE>error</CODE> - Scalar String</A></STRONG><BR>
+<DD>
+On failure, the <CODE>error</CODE> parameter will contain a value which specifies
+which field caused the error. See <A HREF="#group field errors">GROUP FIELD ERRORS</A>.
+<P></P></DL>
+<P>
+<H2><A NAME="groupsetusers(server, group, array)">GroupSetUsers(server, group, array)</A></H2>
+<P>Sets the membership of <CODE>group</CODE> to contain only those users specified
+in <CODE>array</CODE>. This function will fail if any user names contained in the
+array are not valid users on <CODE>server</CODE>.  On successful completion
+<CODE>group</CODE> will contain only the users specified in <CODE>array</CODE>.  Use the
+functions <CODE>GroupAddUser()/GroupDelUser()</CODE> to add and delete individual
+users from a group.</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> on which to set the <CODE>group</CODE> membership.
+<P></P>
+<DT><STRONG><CODE>group</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>group</CODE> to set the membership of.
+<P></P>
+<DT><STRONG><CODE>array</CODE> - Array Reference</STRONG><BR>
+<DD>
+The array containing the names of all users who will be members of <CODE>group</CODE>.
+<P></P></DL>
+<P>
+<HR>
+<H1><A NAME="net local group functions">NET LOCAL GROUP FUNCTIONS</A></H1>
+<P>The <CODE>LocalGroup*()</CODE> functions operate on local groups. If these
+functions are run on a PDC then these functions operate on the domains
+local groups.</P>
+<P>Administrator or Account Operator group membership is required to
 successfully execute most of these functions on a remote server or on a
-computer that has local security enabled.
-
-<P>
-The <A HREF="#item_server">server</A> field can be the empty string, in which case the function defaults to
-running on the local computer. If you leave this field blank then you
-should ensure that you are running the function on a PDC or BDC for your
-current domain. Use the support function <CODE>GetDCName()</CODE> to find out what the domain controller is, should you not be running this
-on the PDC.
-
-<P>
-The following functions are available.
-
-<P>
-<HR>
-<H2><A NAME="LocalGroupAdd_server_level_has">LocalGroupAdd(server, level, hash, error)</A></H2>
-<P>
-Adds the specified group. The name of the group is contained in the <A HREF="#item_name">name</A>
-key of <A HREF="#item_hash">hash</A>.
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> on which to add the group.
-
-<DT><STRONG>level - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_level">level</A> of information contained in <A HREF="#item_hash">hash</A>. This can be one of 0 or 1. See <A HREF="#LOCAL_GROUP_INFO_LEVELS">LOCAL GROUP INFO LEVELS</A>.
-
-<DT><STRONG>hash - Hash Reference</STRONG><DD>
-<P>
-A hash containing the required key/value pairs for <A HREF="#item_level">level</A>.
-
-<DT><STRONG>error - Scalar Int</STRONG><DD>
-<P>
-Provides information on which field in <A HREF="#item_hash">hash</A> wasn't properly specified. See <A HREF="#LOCAL_GROUP_FIELD_ERRORS">LOCAL GROUP FIELD ERRORS</A> for more information about what values this can take.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="LocalGroupAddMember_">LocalGroupAddMember()</A></H2>
-<P>
-This function is obselete in the underlying API and has therefore not been
-implemented. Use <CODE>LocalGroupAddMembers</CODE> instead.
-
-<P>
-<HR>
-<H2><A NAME="LocalGroupAddMembers_server_gro">LocalGroupAddMembers(server, group, array)</A></H2>
-<P>
-Adds the specified users (members) to the local group. Unlike the API
-function <CODE>NetLocalGroupAddMembers()</CODE>, this function does not allow you to specify a level (internally it is
-hardcoded to 3). This was done to simplify the implementation. To add a
-'local' user, you need only specify the <A HREF="#item_name">name</A>. You can also specify users using the
-<CODE>DOMAIN\user</CODE> syntax.
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> on which to add the members to <A HREF="#item_group">group</A>.
-
-<DT><STRONG>group - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_group">group</A> to add the members to.
-
-<DT><STRONG>array - Array Reference</STRONG><DD>
-<P>
-The array containing the members to add to <A HREF="#item_group">group</A>.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="LocalGroupDel_server_group_">LocalGroupDel(server, group)</A></H2>
-<P>
-Delete the specified local group.
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> on which to delete the named <A HREF="#item_group">group</A>.
-
-<DT><STRONG>group -Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_group">group</A> to delete.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="LocalGroupDelMember_">LocalGroupDelMember()</A></H2>
-<P>
-This function is obselete in the underlying API and has therefore not been
-implemented. Use <CODE>LocalGroupDelMembers()</CODE> instead.
-
-<P>
-<HR>
-<H2><A NAME="LocalGroupDelMembers_server_gro">LocalGroupDelMembers(server, group, array)</A></H2>
-<P>
-Delete the specified users (members) of the local group. Unlike the API
-function <CODE>NetLocalGroupDelMembers()</CODE>, this function does not allow you to specify a level (internally it is
-hardcoded to 3). This was done to simplify the implementation. To delete a
-'local' user, you need only specify the <A HREF="#item_name">name</A>. You can also specify users using the <CODE>DOMAIN\user</CODE>
-syntax.
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> on which to delete the members from <A HREF="#item_group">group</A>.
-
-<DT><STRONG>group - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_group">group</A> to delete the members from.
-
-<DT><STRONG>array - Array Reference</STRONG><DD>
-<P>
-The array containing the members to delete from <A HREF="#item_group">group</A>.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="LocalGroupEnum_server_array_">LocalGroupEnum(server, array)</A></H2>
-<P>
-Enumerates all the local groups on the server. Unlike the API call
-<CODE>NetLocalGroupEnum()</CODE>, this function does not allow you to specify a level (internally it is
-hardcoded to 0). In Perl it is trivial to implement the equivalent function
-(should you need it).
-
+computer that has local security enabled.</P>
+<P>The <CODE>server</CODE> field can be the empty string, in which case the function
+defaults to running on the local computer. If you leave this field blank
+then you should ensure that you are running the function on a PDC or BDC
+for your current domain. Use the support function <CODE>GetDCName()</CODE> to find
+out what the domain controller is, should you not be running this on the PDC.</P>
+<P>The following functions are available.</P>
+<P>
+<H2><A NAME="localgroupadd(server, level, hash, error)">LocalGroupAdd(server, level, hash, error)</A></H2>
+<P>Adds the specified group. The name of the group is contained in the <CODE>name</CODE>
+key of <CODE>hash</CODE>.</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> on which to add the group.
+<P></P>
+<DT><STRONG><CODE>level</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>level</CODE> of information contained in <CODE>hash</CODE>. This can be one of 0 or 1.
+See <A HREF="#local group info levels">LOCAL GROUP INFO LEVELS</A>.
+<P></P>
+<DT><STRONG><CODE>hash</CODE> - Hash Reference</STRONG><BR>
+<DD>
+A hash containing the required key/value pairs for <CODE>level</CODE>.
+<P></P>
+<DT><STRONG><CODE>error</CODE> - Scalar Int</STRONG><BR>
+<DD>
+Provides information on which field in <CODE>hash</CODE> wasn't properly specified.
+See <A HREF="#local group field errors">LOCAL GROUP FIELD ERRORS</A> for more information about what values
+this can take.
+<P></P></DL>
+<P>
+<H2><A NAME="localgroupaddmember()"><CODE>LocalGroupAddMember()</CODE></A></H2>
+<P>This function is obselete in the underlying API and has therefore not
+been implemented.  Use <CODE>LocalGroupAddMembers</CODE> instead.</P>
+<P>
+<H2><A NAME="localgroupaddmembers(server, group, array)">LocalGroupAddMembers(server, group, array)</A></H2>
+<P>Adds the specified users (members) to the local group. Unlike the API
+function <CODE>NetLocalGroupAddMembers()</CODE>, this function does not allow you
+to specify a level (internally it is hardcoded to 3).
+This was done to simplify the implementation. To add a 'local' user, you
+need only specify the <CODE>name</CODE>. You can also specify users using the
+<CODE>DOMAIN\user</CODE> syntax.</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> on which to add the members to <CODE>group</CODE>.
+<P></P>
+<DT><STRONG><CODE>group</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>group</CODE> to add the members to.
+<P></P>
+<DT><STRONG><CODE>array</CODE> - Array Reference</STRONG><BR>
+<DD>
+The array containing the members to add to <CODE>group</CODE>.
+<P></P></DL>
+<P>
+<H2><A NAME="localgroupdel(server, group)">LocalGroupDel(server, group)</A></H2>
+<P>Delete the specified local group.</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> on which to delete the named <CODE>group</CODE>.
+<P></P>
+<DT><STRONG><CODE>group</CODE> -Scalar String</STRONG><BR>
+<DD>
+The <CODE>group</CODE> to delete.
+<P></P></DL>
+<P>
+<H2><A NAME="localgroupdelmember()"><CODE>LocalGroupDelMember()</CODE></A></H2>
+<P>This function is obselete in the underlying API and has therefore not
+been implemented.  Use <CODE>LocalGroupDelMembers()</CODE> instead.</P>
+<P>
+<H2><A NAME="localgroupdelmembers(server, group, array)">LocalGroupDelMembers(server, group, array)</A></H2>
+<P>Delete the specified users (members) of the local group. Unlike the API
+function <CODE>NetLocalGroupDelMembers()</CODE>, this function does not allow you
+to specify a level (internally it is hardcoded to 3). This was done to
+simplify the implementation. To delete a 'local' user, you need only
+specify the <CODE>name</CODE>. You can also specify users using the <CODE>DOMAIN\user</CODE>
+syntax.</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> on which to delete the members from <CODE>group</CODE>.
+<P></P>
+<DT><STRONG><CODE>group</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>group</CODE> to delete the members from.
+<P></P>
+<DT><STRONG><CODE>array</CODE> - Array Reference</STRONG><BR>
+<DD>
+The array containing the members to delete from <CODE>group</CODE>.
+<P></P></DL>
+<P>
+<H2><A NAME="localgroupenum(server, array)">LocalGroupEnum(server, array)</A></H2>
+<P>Enumerates all the local groups on the server. Unlike the API call
+<CODE>NetLocalGroupEnum()</CODE>, this function does not allow you to specify a
+level (internally it is hardcoded to 0). In Perl it is trivial to
+implement the equivalent function (should you need it).</P>
 <DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
 The server on which to enumerate the (local) <CODE>groups</CODE>.
-
-<DT><STRONG>array - Array Reference</STRONG><DD>
-<P>
-The array to hold the <A HREF="#item_group">group</A> names.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="LocalGroupGetInfo_server_group_">LocalGroupGetInfo(server, group, level, hash)</A></H2>
-<P>
-Retrieves <A HREF="#item_level">level</A> information for <A HREF="#item_group">group</A>.
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> from which to get the group information.
-
-<DT><STRONG>group - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_group">group</A> whose information you wish to obtain.
-
-<DT><STRONG>level - Scalar Int</STRONG><DD>
-<P>
-The <A HREF="#item_level">level</A> of information you wish to retrieve. This can be 0 or 1. See <A HREF="#LOCAL_GROUP_INFO_LEVELS">LOCAL GROUP INFO LEVELS</A>.
-
-<DT><STRONG>hash - Hash Reference</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><CODE>array</CODE> - Array Reference</STRONG><BR>
+<DD>
+The array to hold the <CODE>group</CODE> names.
+<P></P></DL>
+<P>
+<H2><A NAME="localgroupgetinfo(server, group, level, hash)">LocalGroupGetInfo(server, group, level, hash)</A></H2>
+<P>Retrieves <CODE>level</CODE> information for <CODE>group</CODE>.</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> from which to get the group information.
+<P></P>
+<DT><STRONG><CODE>group</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>group</CODE> whose information you wish to obtain.
+<P></P>
+<DT><STRONG><CODE>level</CODE> - Scalar Int</STRONG><BR>
+<DD>
+The <CODE>level</CODE> of information you wish to retrieve. This can be 0 or 1.
+See <A HREF="#local group info levels">LOCAL GROUP INFO LEVELS</A>.
+<P></P>
+<DT><STRONG><CODE>hash</CODE> - Hash Reference</STRONG><BR>
+<DD>
 The hash that will contain the information.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="LocalGroupGetMembers_server_gro">LocalGroupGetMembers(server, group, hash)</A></H2>
-<P>
-Retrieves the users belonging to <A HREF="#item_group">group</A>. Unlike the API call
-<CODE>NetLocalGroupGetUsers()</CODE>, this function does not allow you to specify a level (internally it is
-hardcoded to 0). In Perl it is trivial to implement the equivalent function
-(should you need it).
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
+<P></P></DL>
 <P>
-The <A HREF="#item_server">server</A> from which to retrieve the group information.
-
-<DT><STRONG>group - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_group">group</A> whose users you wish to obtain.
-
-<DT><STRONG>array - Array Reference</STRONG><DD>
-<P>
+<H2><A NAME="localgroupgetmembers(server, group, hash)">LocalGroupGetMembers(server, group, hash)</A></H2>
+<P>Retrieves the users belonging to <CODE>group</CODE>. Unlike the API call
+<CODE>NetLocalGroupGetUsers()</CODE>, this function does not allow you to specify
+a level (internally it is hardcoded to 0). In Perl it is trivial to
+implement the equivalent function (should you need it).</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> from which to retrieve the group information.
+<P></P>
+<DT><STRONG><CODE>group</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>group</CODE> whose users you wish to obtain.
+<P></P>
+<DT><STRONG><CODE>array</CODE> - Array Reference</STRONG><BR>
+<DD>
 The array to hold the user names retrieved.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="LocalGroupSetInfo_server_level_">LocalGroupSetInfo(server, level, hash, error)</A></H2>
-<P>
-Sets the information for <A HREF="#item_group">group</A> according to <A HREF="#item_level">level</A>.
-
-<DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> on which to set the <A HREF="#item_group">group</A> information.
-
-<DT><STRONG>group - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_group">group</A> whose information you wish to set.
-
-<DT><STRONG>level - Scalar Int</STRONG><DD>
-<P>
-The <A HREF="#item_level">level</A> of information you are supplying in <A HREF="#item_hash">hash</A>. Level can be one of 0 or 1. See <A HREF="#LOCAL_GROUP_INFO_LEVELS">LOCAL GROUP INFO LEVELS</A>.
-
-<DT><STRONG>hash - Hash Reference</STRONG><DD>
-<P>
-The hash containing the required key/value pairs for <A HREF="#item_level">level</A>.
-
-<DT><STRONG>error - Scalar String</STRONG><DD>
-<P>
-On failure, the <A HREF="#item_error">error</A> parameter will contain a value which specifies which field caused the
-error. See <A HREF="#LOCAL_GROUP_FIELD_ERRORS">LOCAL GROUP FIELD ERRORS</A>.
-
-</DL>
-<P>
-<HR>
-<H2><A NAME="LocalGroupSetMembers_">LocalGroupSetMembers()</A></H2>
-<P>
-This function has not been implemented at present.
-
-<P>
-<HR>
-<H1><A NAME="NET_GET_FUNCTIONS">NET GET FUNCTIONS</A></H1>
-<P>
-<HR>
-<H2><A NAME="GetDCName_server_domain_domain">GetDCName(server, domain, domain-controller)</A></H2>
+<P></P></DL>
 <P>
-Gets the <CODE>domain-controllder</CODE> name for <A HREF="#item_server">server</A> and <A HREF="#item_domain">domain</A>.
-
+<H2><A NAME="localgroupsetinfo(server, level, hash, error)">LocalGroupSetInfo(server, level, hash, error)</A></H2>
+<P>Sets the information for <CODE>group</CODE> according to <CODE>level</CODE>.</P>
 <DL>
-<DT><STRONG>server - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_server">server</A> whose domain controller you wish to locate.
-
-<DT><STRONG><A NAME="item_domain">domain - Scalar String</A></STRONG><DD>
-<P>
-The <A HREF="#item_domain">domain</A> that <A HREF="#item_server">server</A> is a member of whose domain-controller you wish the locate.
-
-<DT><STRONG><A NAME="item_domain">domain-controller - Scalar String (output)</A></STRONG><DD>
-<P>
-The name of the <CODE>domain-controller</CODE> for the requested <A HREF="#item_domain">domain</A>.
-
-</DL>
-<P>
-Note: This module does not implement the <CODE>NetGetAnyDCName()</CODE>API function as this is obsolete.
-
-<P>
-<HR>
-<H1><A NAME="USER_INFO_LEVELS">USER INFO LEVELS</A></H1>
-<P>
-Most of the <CODE>User*()</CODE> functions take a <A HREF="#item_level">level</A> parameter. This <A HREF="#item_level">level</A>
-specifies how much detail the corresponding <A HREF="#item_hash">hash</A> should contain (or in the case of a <CODE>UserGet*()</CODE> function, will contain after the call). The following <A HREF="#item_level">level</A> descriptions provide information on what fields should be present for a
-given level. See <A HREF="#USER_INFO_FIELDS">USER INFO FIELDS</A> for a description of the fields.
-
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> on which to set the <CODE>group</CODE> information.
+<P></P>
+<DT><STRONG><CODE>group</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>group</CODE> whose information you wish to set.
+<P></P>
+<DT><STRONG><CODE>level</CODE> - Scalar Int</STRONG><BR>
+<DD>
+The <CODE>level</CODE> of information you are supplying in <CODE>hash</CODE>.
+Level can be one of 0 or 1. See <A HREF="#local group info levels">LOCAL GROUP INFO LEVELS</A>.
+<P></P>
+<DT><STRONG><CODE>hash</CODE> - Hash Reference</STRONG><BR>
+<DD>
+The hash containing the required key/value pairs for <CODE>level</CODE>.
+<P></P>
+<DT><STRONG><CODE>error</CODE> - Scalar String</STRONG><BR>
+<DD>
+On failure, the <CODE>error</CODE> parameter will contain a value which specifies
+which field caused the error. See <A HREF="#local group field errors">LOCAL GROUP FIELD ERRORS</A>.
+<P></P></DL>
+<P>
+<H2><A NAME="localgroupsetmembers()"><CODE>LocalGroupSetMembers()</CODE></A></H2>
+<P>This function has not been implemented at present.</P>
+<P>
+<HR>
+<H1><A NAME="net get functions">NET GET FUNCTIONS</A></H1>
+<P>
+<H2><A NAME="getdcname(server, domain, domaincontroller)">GetDCName(server, domain, domain-controller)</A></H2>
+<P>Gets the <CODE>domain-controller</CODE> name for <CODE>server</CODE> and <CODE>domain</CODE>.</P>
+<DL>
+<DT><STRONG><CODE>server</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>server</CODE> whose domain controller you wish to locate.
+<P></P>
+<DT><STRONG><A NAME="item_domain_%2D_Scalar_String"><CODE>domain</CODE> - Scalar String</A></STRONG><BR>
+<DD>
+The <CODE>domain</CODE> that <CODE>server</CODE> is a member of whose domain-controller
+you wish the locate.
+<P></P>
+<DT><STRONG><A NAME="item_String"><CODE>domain-controller</CODE> - Scalar String (output)</A></STRONG><BR>
+<DD>
+The name of the <CODE>domain-controller</CODE> for the requested <CODE>domain</CODE>.
+<P></P></DL>
+<P>Note: This module does not implement the <CODE>NetGetAnyDCName()</CODE>API function
+as this is obsolete.</P>
+<P>
+<HR>
+<H1><A NAME="user info levels">USER INFO LEVELS</A></H1>
+<P>Most of the <CODE>User*()</CODE> functions take a <CODE>level</CODE> parameter. This <CODE>level</CODE>
+specifies how much detail the corresponding <CODE>hash</CODE> should contain (or in
+the case of a <CODE>UserGet*()</CODE> function, will contain after the call). The
+following <CODE>level</CODE> descriptions provide information on what fields should
+be present for a given level. See <A HREF="#user info fields">USER INFO FIELDS</A> for a description of
+the fields.</P>
 <DL>
-<DT><STRONG><A NAME="item_Level">Level 0</A></STRONG><DD>
-<P>
+<DT><STRONG><A NAME="item_Level_0">Level 0</A></STRONG><BR>
+<DD>
 name
-
-<DT><STRONG>Level 1</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1">Level 1</A></STRONG><BR>
+<DD>
 name, password, passwordAge, priv, homeDir, comment, flags, scriptPath
-
-<DT><STRONG>Level 2</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_2">Level 2</A></STRONG><BR>
+<DD>
 name, password, passwordAge, priv, homeDir, comment, flags, scriptPath,
 authFlags, fullName, usrComment, parms, workstations, lastLogon,
 lastLogoff, acctExpires, maxStorage, unitsPerWeek, logonHours, badPwCount,
 numLogons, logonServer, countryCode, codePage
-
-<DT><STRONG>Level 3</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_3">Level 3</A></STRONG><BR>
+<DD>
 name, password, passwordAge, priv, homeDir, comment, flags, scriptPath,
-authFlags, fullName, usrComment, parms, workstations, lastLogon,
-lastLogoff, acctExpires, maxStorage, unitsPerWeek, logonHours, badPwCount,
-numLogons, logonServer, countryCode, codePage, userId, primaryGroupId,
-profile, homeDirDrive, passwordExpired
-
-<DT><STRONG>Level 10</STRONG><DD>
-<P>
+authFlags, fullName, usrComment, parms, workstations, lastLogon, lastLogoff,
+acctExpires, maxStorage, unitsPerWeek, logonHours, badPwCount, numLogons,
+logonServer, countryCode, codePage, userId, primaryGroupId, profile,
+homeDirDrive, passwordExpired
+<P></P>
+<DT><STRONG><A NAME="item_Level_10">Level 10</A></STRONG><BR>
+<DD>
 name, comment, usrComment, fullName
-
-<DT><STRONG>Level 11</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_11">Level 11</A></STRONG><BR>
+<DD>
 name, comment, usrComment, fullName, priv, authFlags, passwordAge, homeDir,
 parms, lastLogon, lastLogoff, badPwCount, numLogons, logonServer,
 countryCode, workstations, maxStorage, unitsPerWeek, logonHours, codePage
-
-<DT><STRONG>Level 20</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_20">Level 20</A></STRONG><BR>
+<DD>
 name, fullName, comment, flags, userId
-
-<DT><STRONG>Level 21</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_21">Level 21</A></STRONG><BR>
+<DD>
 <STRONG>Not available in this implementation</STRONG>
-
-
-
-<DT><STRONG>Level 22</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_22">Level 22</A></STRONG><BR>
+<DD>
 <STRONG>Not available in this implementation</STRONG>
-
-
-
-<DT><STRONG>Level 1003</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1003">Level 1003</A></STRONG><BR>
+<DD>
 password
-
-<DT><STRONG>Level 1005</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1005">Level 1005</A></STRONG><BR>
+<DD>
 priv
-
-<DT><STRONG>Level 1006</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1006">Level 1006</A></STRONG><BR>
+<DD>
 homeDir
-
-<DT><STRONG>Level 1007</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1007">Level 1007</A></STRONG><BR>
+<DD>
 comment
-
-<DT><STRONG>Level 1008</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1008">Level 1008</A></STRONG><BR>
+<DD>
 flags
-
-<DT><STRONG>Level 1009</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1009">Level 1009</A></STRONG><BR>
+<DD>
 scriptPath
-
-<DT><STRONG>Level 1010</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1010">Level 1010</A></STRONG><BR>
+<DD>
 authFlags
-
-<DT><STRONG>Level 1011</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1011">Level 1011</A></STRONG><BR>
+<DD>
 fullName
-
-<DT><STRONG>Level 1012</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1012">Level 1012</A></STRONG><BR>
+<DD>
 usrComment
-
-<DT><STRONG>Level 1013</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1013">Level 1013</A></STRONG><BR>
+<DD>
 parms
-
-<DT><STRONG>Level 1014</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1014">Level 1014</A></STRONG><BR>
+<DD>
 workstations
-
-<DT><STRONG>Level 1017</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1017">Level 1017</A></STRONG><BR>
+<DD>
 acctExpires
-
-<DT><STRONG>Level 1018</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1018">Level 1018</A></STRONG><BR>
+<DD>
 maxStorage
-
-<DT><STRONG>Level 1020</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1020">Level 1020</A></STRONG><BR>
+<DD>
 unitsPerWeek, logonHours
-
-<DT><STRONG>Level 1023</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1023">Level 1023</A></STRONG><BR>
+<DD>
 logonServer
-
-<DT><STRONG>Level 1024</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1024">Level 1024</A></STRONG><BR>
+<DD>
 countryCode
-
-<DT><STRONG>Level 1025</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1025">Level 1025</A></STRONG><BR>
+<DD>
 codePage
-
-<DT><STRONG>Level 1051</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1051">Level 1051</A></STRONG><BR>
+<DD>
 primaryGroupId
-
-<DT><STRONG>Level 1052</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1052">Level 1052</A></STRONG><BR>
+<DD>
 profile
-
-<DT><STRONG>Level 1053</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1053">Level 1053</A></STRONG><BR>
+<DD>
 homeDirDrive
-
-</DL>
+<P></P></DL>
 <P>
 <HR>
-<H1><A NAME="USER_INFO_FIELDS">USER INFO FIELDS</A></H1>
-<P>
-The following is an alphabetical listing of each possible field, together
-with the data type that the field is expected to contain.
-
+<H1><A NAME="user info fields">USER INFO FIELDS</A></H1>
+<P>The following is an alphabetical listing of each possible field, together
+with the data type that the field is expected to contain.</P>
 <DL>
-<DT><STRONG><A NAME="item_acctExpires">acctExpires - Scalar Int (UTC)</A></STRONG><DD>
-<P>
+<DT><STRONG><CODE>acctExpires</CODE> - Scalar Int (UTC)</STRONG><BR>
+<DD>
 The time (as the number of seconds since 00:00:00, 1st January 1970) when
 the account expires. A -1 in this field specifies that the account never
 expires.
-
-<DT><STRONG><A NAME="item_authFlags">authFlags - Scalar Int (See USER_AUTH_FLAGS).</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><CODE>authFlags</CODE> - Scalar Int (See USER_AUTH_FLAGS).</STRONG><BR>
+<DD>
 The level of authority that this use has. The value this can take depends
 on the users group membership - this value is therefore read only and
-cannot be set using <CODE>UserAdd()</CODE> or <CODE>UserSetInfo()</CODE>. Its value can be one of:
-
-</DL>
-<P>
-<PRE>        User belongs to group           Flag value
+cannot be set using <CODE>UserAdd()</CODE> or <CODE>UserSetInfo()</CODE>. Its value can be one
+of:
+<P></P></DL>
+<PRE>
+        User belongs to group           Flag value
         ---------------------           ----------
         Print Operators                 Win32API::Net::AF_OP_PRINT()
         Server Operators                Win32API::Net::AF_OP_SERVER()
-        Account Operators               Win32API::Net::AF_OP_ACCOUNTS()
-</PRE>
+        Account Operators               Win32API::Net::AF_OP_ACCOUNTS()</PRE>
 <DL>
-<DT><STRONG><A NAME="item_badPwCount">badPwCount - Scalar Int</A></STRONG><DD>
-<P>
+<DT><STRONG><A NAME="item_badPwCount_%2D_Scalar_Int"><CODE>badPwCount</CODE> - Scalar Int</A></STRONG><BR>
+<DD>
 The number of times that the user has failed to logon by specifying an
 incorrect password.
-
-<DT><STRONG><A NAME="item_codePage">codePage - Scalar Int</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_codePage_%2D_Scalar_Int"><CODE>codePage</CODE> - Scalar Int</A></STRONG><BR>
+<DD>
 The code page that this user uses.
-
-<DT><STRONG><A NAME="item_comment">comment - Scalar String</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_comment_%2D_Scalar_String"><CODE>comment</CODE> - Scalar String</A></STRONG><BR>
+<DD>
 The comment associated with this user account. This can be any string
 (apparently of any length).
-
-<DT><STRONG><A NAME="item_countryCode">countryCode - Scalar Int</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_countryCode_%2D_Scalar_Int"><CODE>countryCode</CODE> - Scalar Int</A></STRONG><BR>
+<DD>
 The country code that this user uses.
-
-<DT><STRONG>flags - Scalar Int (Bitwise OR of USER_FLAGS)</STRONG><DD>
-<P>
-The flags for this user. See <A HREF="#USER_FLAGS">USER FLAGS</A>.
-
-<DT><STRONG><A NAME="item_fullName">fullName - Scalar String</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><CODE>flags</CODE> - Scalar Int (Bitwise OR of USER_FLAGS)</STRONG><BR>
+<DD>
+The flags for this user. See <A HREF="#user flags">USER FLAGS</A>.
+<P></P>
+<DT><STRONG><A NAME="item_fullName_%2D_Scalar_String"><CODE>fullName</CODE> - Scalar String</A></STRONG><BR>
+<DD>
 The users' full name.
-
-<DT><STRONG><A NAME="item_homeDir">homeDir - Scalar String</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_homeDir_%2D_Scalar_String"><CODE>homeDir</CODE> - Scalar String</A></STRONG><BR>
+<DD>
 The home directory of the user. This can be either a UNC path or an
 absolute path (drive letter + path). Can be the empty string (``'').
-
-<DT><STRONG><A NAME="item_homeDirDrive">homeDirDrive - Scalar String</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_homeDirDrive_%2D_Scalar_String"><CODE>homeDirDrive</CODE> - Scalar String</A></STRONG><BR>
+<DD>
 The home directory drive that the users home directory is mapped to
 (assuming that the specified home directory is a UNC path).
-
-<DT><STRONG><A NAME="item_lastLogon">lastLogon - Scalar Int (UTC)</A></STRONG><DD>
-<P>
-The time (as the number of seconds since 00:00:00, 1st January 1970) that
-the user last logged on.
-
-<DT><STRONG><A NAME="item_lastLogoff">lastLogoff - Scalar Int (UTC)</A></STRONG><DD>
-<P>
-The time (as the number of seconds since 00:00:00, 1st January 1970) that
-the user last logged off .
-
-<DT><STRONG><A NAME="item_logonHours">logonHours - Reference to Array of Integers (length 21 elements)</A></STRONG><DD>
-<P>
-The times at which the user can logon. This should be an integer array with
-21 elements. Each element represents an 8 hour period and each bit
-represents represents an hour. Only the lower byte of each integer is used.
-If this is left undefined then no restrictions are placed on the account.
-
-<DT><STRONG><A NAME="item_logonServer">logonServer - Scalar String</A></STRONG><DD>
-<P>
-The logon server for this user. Under Windows NT, this value cannot be set
-and will always have the value '\\*' when queried.
-
-<DT><STRONG><A NAME="item_maxStorage">maxStorage - Scalar Int</A></STRONG><DD>
-<P>
-The current release of Windows NT does not implement disk quotas so it is
-believed that the value of this key is ignored.
-
-<DT><STRONG><A NAME="item_name">name - Scalar String</A></STRONG><DD>
-<P>
-The user name that this request applies to. Most of the functions take the
-user name as a separate argument. In general, the user name provided should
-be the same as that in the one provided in the hash.
-
-<DT><STRONG><A NAME="item_numLogons">numLogons - Scalar Int</A></STRONG><DD>
-<P>
-The number of times that the named user has successfully logged on to this
-machine/domain.
-
-<DT><STRONG><A NAME="item_parms">parms - Scalar String</A></STRONG><DD>
-<P>
-The value of this key can be used by applications. There are none known to
-to author that use it, although it could be used to hold adminitrative
+<P></P>
+<DT><STRONG><CODE>lastLogon</CODE> - Scalar Int (UTC)</STRONG><BR>
+<DD>
+The time (as the number of seconds since 00:00:00, 1st January 1970)
+that the user last logged on.
+<P></P>
+<DT><STRONG><CODE>lastLogoff</CODE> - Scalar Int (UTC)</STRONG><BR>
+<DD>
+The time (as the number of seconds since 00:00:00, 1st January 1970)
+that the user last logged off .
+<P></P>
+<DT><STRONG><A NAME="item_Integers"><CODE>logonHours</CODE> - Reference to Array of Integers (length 21 elements)</A></STRONG><BR>
+<DD>
+The times at which the user can logon. This should be an integer array
+with 21 elements.  Each element represents an 8 hour period and each bit
+represents represents an hour. Only the lower byte of each integer is
+used. If this is left undefined then no restrictions are placed on the
+account.
+<P></P>
+<DT><STRONG><A NAME="item_logonServer_%2D_Scalar_String"><CODE>logonServer</CODE> - Scalar String</A></STRONG><BR>
+<DD>
+The logon server for this user. Under Windows NT, this value cannot be
+set and will always have the value '\\*' when queried.
+<P></P>
+<DT><STRONG><A NAME="item_maxStorage_%2D_Scalar_Int"><CODE>maxStorage</CODE> - Scalar Int</A></STRONG><BR>
+<DD>
+The current release of Windows NT does not implement disk quotas so
+it is believed that the value of this key is ignored.
+<P></P>
+<DT><STRONG><A NAME="item_name_%2D_Scalar_String"><CODE>name</CODE> - Scalar String</A></STRONG><BR>
+<DD>
+The user name that this request applies to. Most of the functions take
+the user name as a separate argument. In general, the user name provided
+should be the same as that in the one provided in the hash.
+<P></P>
+<DT><STRONG><A NAME="item_numLogons_%2D_Scalar_Int"><CODE>numLogons</CODE> - Scalar Int</A></STRONG><BR>
+<DD>
+The number of times that the named user has successfully logged on to
+this machine/domain.
+<P></P>
+<DT><STRONG><A NAME="item_parms_%2D_Scalar_String"><CODE>parms</CODE> - Scalar String</A></STRONG><BR>
+<DD>
+The value of this key can be used by applications. There are none known
+to to author that use it, although it could be used to hold adminitrative
 information.
-
-<DT><STRONG><A NAME="item_password">password - Scalar String</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_password_%2D_Scalar_String"><CODE>password</CODE> - Scalar String</A></STRONG><BR>
+<DD>
 The password to be set. The password is never returned in a <CODE>UserGet()</CODE>
 operation.
-
-<DT><STRONG><A NAME="item_passwordAge">passwordAge - Scalar Int (UTC)</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><CODE>passwordAge</CODE> - Scalar Int (UTC)</STRONG><BR>
+<DD>
 The current age of the password (stored as the number of seconds since
 00:00:00, 1st January 1970).
-
-<DT><STRONG><A NAME="item_passwordExpired">passwordExpired - Scalar Int</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_passwordExpired_%2D_Scalar_Int"><CODE>passwordExpired</CODE> - Scalar Int</A></STRONG><BR>
+<DD>
 The value of this key is used in two different ways. When queried via
-<CODE>UserGetInfo()</CODE> the return value is 0 is the password has not expired and 1 if it has. When
-setting the value via <CODE>UserAdd()</CODE> or
-<CODE>UserSetInfo()</CODE> a value of 0 indicates that the users' password has not expired whereas a
-value of 1 will force the user to change their password at the next logon.
-
-<DT><STRONG><A NAME="item_primaryGroupId">primaryGroupId - Scalar Int</A></STRONG><DD>
-<P>
+<CODE>UserGetInfo()</CODE> the return value is 0 is the password has not expired
+and 1 if it has. When setting the value via <CODE>UserAdd()</CODE> or
+<CODE>UserSetInfo()</CODE> a value of 0 indicates that the users' password has
+not expired whereas a value of 1 will force the user to change their
+password at the next logon.
+<P></P>
+<DT><STRONG><A NAME="item_primaryGroupId_%2D_Scalar_Int"><CODE>primaryGroupId</CODE> - Scalar Int</A></STRONG><BR>
+<DD>
 The id of the primary group that this user belongs to. When creating
 accounts with <CODE>UserAdd()</CODE> you should use a value of 0x201.
-
-<DT><STRONG><A NAME="item_priv">priv - Scalar Int (Bitwise OR of USER_PRIVILEGE_FLAGS)</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><CODE>priv</CODE> - Scalar Int (Bitwise OR of USER_PRIVILEGE_FLAGS)</STRONG><BR>
+<DD>
 The privilege level that this user has. This is never returned from a
-<CODE>UserGet()</CODE> call. See <A HREF="#USER_PRIVILEGE_FLAGS">USER PRIVILEGE FLAGS</A>.
-
-<DT><STRONG><A NAME="item_profile">profile - Scalar String</A></STRONG><DD>
-<P>
-The profile that is associated with the named user. This can be UNC path, a
-local path or undefined.
-
-<DT><STRONG><A NAME="item_scriptPath">scriptPath - Scalar String</A></STRONG><DD>
-<P>
+<CODE>UserGet()</CODE> call. See <A HREF="#user privilege flags">USER PRIVILEGE FLAGS</A>.
+<P></P>
+<DT><STRONG><A NAME="item_profile_%2D_Scalar_String"><CODE>profile</CODE> - Scalar String</A></STRONG><BR>
+<DD>
+The profile that is associated with the named user. This can be UNC path,
+a local path or undefined.
+<P></P>
+<DT><STRONG><A NAME="item_scriptPath_%2D_Scalar_String"><CODE>scriptPath</CODE> - Scalar String</A></STRONG><BR>
+<DD>
 The path to the logon script for this user. This should be specified as a
 relative path and will cause the logon script to be run from (relative
 location) in the logon servers export directory.
-
-<DT><STRONG><A NAME="item_unitsPerWeek">unitsPerWeek - Scalar Int</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_unitsPerWeek_%2D_Scalar_Int"><CODE>unitsPerWeek</CODE> - Scalar Int</A></STRONG><BR>
+<DD>
 The value of this key represents the granularity of the logonHours array.
 Its use is beyond the scope of this package.
-
-<DT><STRONG><A NAME="item_usrComment">usrComment - Scalar String</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_usrComment_%2D_Scalar_String"><CODE>usrComment</CODE> - Scalar String</A></STRONG><BR>
+<DD>
 The user comment field (contrasted with the comment field ;-).
-
-<DT><STRONG><A NAME="item_workstations">workstations - Scalar String</A></STRONG><DD>
-<P>
-A comma-separated string containing upto 8 workstation that the named user
-can login to. Setting a value for this key will then allow the named user
-to login to only those computers named.
-
-<DT><STRONG><A NAME="item_userId">userId - Scalar Int</A></STRONG><DD>
-<P>
-The user id associated with this user This value is generated by the system
-and cannot be set or changed using the <CODE>UserAdd()</CODE> or
+<P></P>
+<DT><STRONG><A NAME="item_workstations_%2D_Scalar_String"><CODE>workstations</CODE> - Scalar String</A></STRONG><BR>
+<DD>
+A comma-separated string containing upto 8 workstation that the named
+user can login to.  Setting a value for this key will then allow the
+named user to login to only those computers named.
+<P></P>
+<DT><STRONG><A NAME="item_userId_%2D_Scalar_Int"><CODE>userId</CODE> - Scalar Int</A></STRONG><BR>
+<DD>
+The user id associated with this user This value is generated by the
+system and cannot be set or changed using the <CODE>UserAdd()</CODE> or
 <CODE>UserSetInfo()</CODE> calls.
-
-</DL>
+<P></P></DL>
 <P>
 <HR>
-<H1><A NAME="USER_FLAGS">USER FLAGS</A></H1>
-<P>
-The following is an alphabetical listing of the user flags. The <A HREF="#item_flags">flags</A> key (see <A HREF="#USER_INFO_FIELDS">USER INFO FIELDS</A>) should be the bitwise OR of one or more of these values.
-
+<H1><A NAME="user flags">USER FLAGS</A></H1>
+<P>The following is an alphabetical listing of the user flags.
+The <CODE>flags</CODE> key (see <A HREF="#user info fields">USER INFO FIELDS</A>) should be the bitwise OR of one
+or more of these values.</P>
 <DL>
-<DT><STRONG><A NAME="item_UF_ACCOUNTDISABLE">UF_ACCOUNTDISABLE()</A></STRONG><DD>
-<P>
+<DT><STRONG><A NAME="item_UF_ACCOUNTDISABLE"><CODE>UF_ACCOUNTDISABLE()</CODE></A></STRONG><BR>
+<DD>
 This account has been disabled.
-
-<DT><STRONG><A NAME="item_UF_DONT_EXPIRE_PASSWD">UF_DONT_EXPIRE_PASSWD()</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_UF_DONT_EXPIRE_PASSWD"><CODE>UF_DONT_EXPIRE_PASSWD()</CODE></A></STRONG><BR>
+<DD>
 Never expire the password on this account.
-
-<DT><STRONG><A NAME="item_UF_HOMEDIR_REQUIRED">UF_HOMEDIR_REQUIRED()</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_UF_HOMEDIR_REQUIRED"><CODE>UF_HOMEDIR_REQUIRED()</CODE></A></STRONG><BR>
+<DD>
 A home directory must be specified (ignored for NT).
-
-<DT><STRONG><A NAME="item_UF_INTERDOMAIN_TRUST_ACCOUNT">UF_INTERDOMAIN_TRUST_ACCOUNT()</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_UF_INTERDOMAIN_TRUST_ACCOUNT"><CODE>UF_INTERDOMAIN_TRUST_ACCOUNT()</CODE></A></STRONG><BR>
+<DD>
 The account represents a interdomain trust account.
-
-<DT><STRONG><A NAME="item_UF_LOCKOUT">UF_LOCKOUT()</A></STRONG><DD>
-<P>
-Lock out this account (or this account has been locked out due to security
-policy - i.e. badLogonCount is greater than your policy allows). This value
-can be cleared but not set by a <CODE>UserSetInfo()</CODE> call.
-
-<DT><STRONG><A NAME="item_UF_NORMAL_ACCOUNT">UF_NORMAL_ACCOUNT()</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_UF_LOCKOUT"><CODE>UF_LOCKOUT()</CODE></A></STRONG><BR>
+<DD>
+Lock out this account (or this account has been locked out due to
+security policy - i.e.  badLogonCount is greater than your policy allows).
+This value can be cleared but not set by a <CODE>UserSetInfo()</CODE> call.
+<P></P>
+<DT><STRONG><A NAME="item_UF_NORMAL_ACCOUNT"><CODE>UF_NORMAL_ACCOUNT()</CODE></A></STRONG><BR>
+<DD>
 The account is a normal user account.
-
-<DT><STRONG><A NAME="item_UF_PASSWD_CANT_CHANGE">UF_PASSWD_CANT_CHANGE()</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_UF_PASSWD_CANT_CHANGE"><CODE>UF_PASSWD_CANT_CHANGE()</CODE></A></STRONG><BR>
+<DD>
 The password for this account cannot be changed (execpt by an Administrator
 using one of the above calls).
-
-<DT><STRONG><A NAME="item_UF_PASSWD_NOTREQD">UF_PASSWD_NOTREQD()</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_UF_PASSWD_NOTREQD"><CODE>UF_PASSWD_NOTREQD()</CODE></A></STRONG><BR>
+<DD>
 A password is not required for this account.
-
-<DT><STRONG><A NAME="item_UF_SCRIPT">UF_SCRIPT()</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_UF_SCRIPT"><CODE>UF_SCRIPT()</CODE></A></STRONG><BR>
+<DD>
 This &lt;strong&gt;must be set when creating account on Windows NT.
-
-<DT><STRONG><A NAME="item_UF_SERVER_TRUST_ACCOUNT">UF_SERVER_TRUST_ACCOUNT()</A></STRONG><DD>
-<P>
-The account represents a Windows NT Backup Domain Controller account in the
-domain.
-
-<DT><STRONG><A NAME="item_UF_TEMP_DUPLICATE_ACCOUNT">UF_TEMP_DUPLICATE_ACCOUNT()</A></STRONG><DD>
-<P>
-To quote the Microsoft Documentation &lt;em&gt;&amp;quot;This is an account
-for users whose primary account is in another domain. This account provides
+<P></P>
+<DT><STRONG><A NAME="item_UF_SERVER_TRUST_ACCOUNT"><CODE>UF_SERVER_TRUST_ACCOUNT()</CODE></A></STRONG><BR>
+<DD>
+The account represents a Windows NT Backup Domain Controller account in
+the domain.
+<P></P>
+<DT><STRONG><A NAME="item_UF_TEMP_DUPLICATE_ACCOUNT"><CODE>UF_TEMP_DUPLICATE_ACCOUNT()</CODE></A></STRONG><BR>
+<DD>
+To quote the Microsoft Documentation &lt;em&gt;&amp;quot;This is an account for
+users whose primary account is in another domain. This account provides
 user access to this domain, but not to any domain that trusts this domain.
 The User Manager refers to this account type as a local user account.
-
-<DT><STRONG><A NAME="item_UF_WORKSTATION_TRUST_ACCOUNT">UF_WORKSTATION_TRUST_ACCOUNT()</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_UF_WORKSTATION_TRUST_ACCOUNT"><CODE>UF_WORKSTATION_TRUST_ACCOUNT()</CODE></A></STRONG><BR>
+<DD>
 The account represents a computer account for a workstation or server in
 the domain.
-
-</DL>
-<P>
-Please note that these are implemented as functions and are therefore
+<P></P></DL>
+<P>Please note that these are implemented as functions and are therefore
 called in the same way as other functions. You should typically use them
-like:
-
-<P>
-<PRE>        $ufScript = Win32API::Net::UF_SCRIPT();
-</PRE>
+like:</P>
+<PRE>
+        $ufScript = Win32API::Net::UF_SCRIPT();</PRE>
 <P>
 <HR>
-<H1><A NAME="USER_PRIVILEGE_FLAGS">USER PRIVILEGE FLAGS</A></H1>
-<P>
-These following values are used in the <A HREF="#item_priv">priv</A> key. This field is never initialised on a <CODE>UserGet*()</CODE> call and once set cannot be changed in a
-<CODE>UserSetInfo()</CODE> call.
-
+<H1><A NAME="user privilege flags">USER PRIVILEGE FLAGS</A></H1>
+<P>These following values are used in the <CODE>priv</CODE> key. This field is never
+initialised on a <CODE>UserGet*()</CODE> call and once set cannot be changed in a
+<CODE>UserSetInfo()</CODE> call.</P>
 <DL>
-<DT><STRONG><A NAME="item_USER_PRIV_ADMIN">USER_PRIV_ADMIN()</A></STRONG><DD>
-<P>
+<DT><STRONG><A NAME="item_USER_PRIV_ADMIN"><CODE>USER_PRIV_ADMIN()</CODE></A></STRONG><BR>
+<DD>
 Account is an an administrative account.
-
-<DT><STRONG><A NAME="item_USER_PRIV_GUEST">USER_PRIV_GUEST()</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_USER_PRIV_GUEST"><CODE>USER_PRIV_GUEST()</CODE></A></STRONG><BR>
+<DD>
 Account is a guest account.
-
-<DT><STRONG><A NAME="item_USER_PRIV_USER">USER_PRIV_USER()</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_USER_PRIV_USER"><CODE>USER_PRIV_USER()</CODE></A></STRONG><BR>
+<DD>
 Account is a user account.
-
-</DL>
-<P>
-Please note that these are implemented as functions and are therefore
+<P></P></DL>
+<P>Please note that these are implemented as functions and are therefore
 called in the same way as other functions. You should typically use them
-like:
-
-<P>
-<PRE>        $userPrivUser = Win32API::Net::USER_PRIV_USER();
-</PRE>
+like:</P>
+<PRE>
+        $userPrivUser = Win32API::Net::USER_PRIV_USER();</PRE>
 <P>
 <HR>
-<H1><A NAME="USER_ENUM_FILTER">USER ENUM FILTER</A></H1>
-<P>
-These flags are used in the <CODE>UserEnum()</CODE> function to specify which accounts to retrieve. It should be a bitwise OR
-of some (or all) of the following.
-
+<H1><A NAME="user enum filter">USER ENUM FILTER</A></H1>
+<P>These flags are used in the <CODE>UserEnum()</CODE> function to specify which
+accounts to retrieve. It should be a bitwise OR of some (or all) of
+the following.</P>
 <DL>
-<DT><STRONG><A NAME="item_FILTER_TEMP_DUPLICATE_ACCOUNT">FILTER_TEMP_DUPLICATE_ACCOUNT()</A></STRONG><DD>
-<P>
+<DT><STRONG><A NAME="item_FILTER_TEMP_DUPLICATE_ACCOUNT"><CODE>FILTER_TEMP_DUPLICATE_ACCOUNT()</CODE></A></STRONG><BR>
+<DD>
 Show temporary duplicate account (one presumes).
-
-<DT><STRONG><A NAME="item_FILTER_NORMAL_ACCOUNT">FILTER_NORMAL_ACCOUNT()</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_FILTER_NORMAL_ACCOUNT"><CODE>FILTER_NORMAL_ACCOUNT()</CODE></A></STRONG><BR>
+<DD>
 Show normal user account.
-
-<DT><STRONG><A NAME="item_FILTER_INTERDOMAIN_TRUST_ACCOUNT">FILTER_INTERDOMAIN_TRUST_ACCOUNT()</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_FILTER_INTERDOMAIN_TRUST_ACCOUNT"><CODE>FILTER_INTERDOMAIN_TRUST_ACCOUNT()</CODE></A></STRONG><BR>
+<DD>
 Show interdomain trust accounts.
-
-<DT><STRONG><A NAME="item_FILTER_WORKSTATION_TRUST_ACCOUNT">FILTER_WORKSTATION_TRUST_ACCOUNT()</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_FILTER_WORKSTATION_TRUST_ACCOUNT"><CODE>FILTER_WORKSTATION_TRUST_ACCOUNT()</CODE></A></STRONG><BR>
+<DD>
 Show workstation trust accounts.
-
-<DT><STRONG><A NAME="item_FILTER_SERVER_TRUST_ACCOUNT">FILTER_SERVER_TRUST_ACCOUNT()</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_FILTER_SERVER_TRUST_ACCOUNT"><CODE>FILTER_SERVER_TRUST_ACCOUNT()</CODE></A></STRONG><BR>
+<DD>
 Show server trust accounts.
-
-</DL>
-<P>
-Please note that these are implemented as functions and are therefore
+<P></P></DL>
+<P>Please note that these are implemented as functions and are therefore
 called in the same way as other functions. You should typically use them
-like:
-
-<P>
-<PRE>        $filterNormalAccounts = Win32API::Net::FILTER_NORMAL_ACCOUNT();
-</PRE>
-<P>
-<HR>
-<H1><A NAME="USER_FIELD_ERRORS">USER FIELD ERRORS</A></H1>
-<P>
-For the <CODE>User*()</CODE> functions that take an <A HREF="#item_error">error</A> parameter this variable will, on failure, contain one of the following
-constants. Note that the function may fail because more than one key/value
-was missing from the input hash. You will only find out about the first one
-that was incorrectly specified. This is only really useful in debugging.
-
-<DL>
-<DT><STRONG><A NAME="item_USER_ACCT_EXPIRES_PARMNUM">USER_ACCT_EXPIRES_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_acctExpires">acctExpires</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_AUTH_FLAGS_PARMNUM">USER_AUTH_FLAGS_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_authFlags">authFlags</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_BAD_PW_COUNT_PARMNUM">USER_BAD_PW_COUNT_PARMNUM()</A></STRONG><DD>
-<P>
+like:</P>
+<PRE>
+        $filterNormalAccounts = Win32API::Net::FILTER_NORMAL_ACCOUNT();</PRE>
+<P>
+<HR>
+<H1><A NAME="user field errors">USER FIELD ERRORS</A></H1>
+<P>For the <CODE>User*()</CODE> functions that take an <CODE>error</CODE> parameter this variable
+will, on failure, contain one of the following constants. Note that the
+function may fail because more than one key/value was missing from the
+input hash. You will only find out about the first one that was incorrectly
+specified. This is only really useful in debugging.</P>
+<DL>
+<DT><STRONG><A NAME="item_USER_ACCT_EXPIRES_PARMNUM"><CODE>USER_ACCT_EXPIRES_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>acctExpires</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_AUTH_FLAGS_PARMNUM"><CODE>USER_AUTH_FLAGS_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>authFlags</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_BAD_PW_COUNT_PARMNUM"><CODE>USER_BAD_PW_COUNT_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
 <CODE>badPasswordCount</CODE> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_CODE_PAGE_PARMNUM">USER_CODE_PAGE_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_codePage">codePage</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_COMMENT_PARMNUM">USER_COMMENT_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_comment">comment</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_COUNTRY_CODE_PARMNUM">USER_COUNTRY_CODE_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_countryCode">countryCode</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_FLAGS_PARMNUM">USER_FLAGS_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_flags">flags</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_FULL_NAME_PARMNUM">USER_FULL_NAME_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_fullName">fullName</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_HOME_DIR_DRIVE_PARMNUM">USER_HOME_DIR_DRIVE_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_homeDirDrive">homeDirDrive</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_HOME_DIR_PARMNUM">USER_HOME_DIR_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_homeDir">homeDir</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_LAST_LOGOFF_PARMNUM">USER_LAST_LOGOFF_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_lastLogoff">lastLogoff</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_LAST_LOGON_PARMNUM">USER_LAST_LOGON_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_lastLogon">lastLogon</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_LOGON_HOURS_PARMNUM">USER_LOGON_HOURS_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_logonHours">logonHours</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_LOGON_SERVER_PARMNUM">USER_LOGON_SERVER_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_logonServer">logonServer</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_MAX_STORAGE_PARMNUM">USER_MAX_STORAGE_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_maxStorage">maxStorage</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_NAME_PARMNUM">USER_NAME_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_name">name</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_NUM_LOGONS_PARMNUM">USER_NUM_LOGONS_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_numLogons">numLogons</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_PARMS_PARMNUM">USER_PARMS_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_parms">parms</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_PASSWORD_AGE_PARMNUM">USER_PASSWORD_AGE_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_passwordAge">passwordAge</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_PASSWORD_PARMNUM">USER_PASSWORD_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_password">password</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_PRIMARY_GROUP_PARMNUM">USER_PRIMARY_GROUP_PARMNUM()</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_USER_CODE_PAGE_PARMNUM"><CODE>USER_CODE_PAGE_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>codePage</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_COMMENT_PARMNUM"><CODE>USER_COMMENT_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>comment</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_COUNTRY_CODE_PARMNUM"><CODE>USER_COUNTRY_CODE_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>countryCode</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_FLAGS_PARMNUM"><CODE>USER_FLAGS_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>flags</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_FULL_NAME_PARMNUM"><CODE>USER_FULL_NAME_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>fullName</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_HOME_DIR_DRIVE_PARMNUM"><CODE>USER_HOME_DIR_DRIVE_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>homeDirDrive</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_HOME_DIR_PARMNUM"><CODE>USER_HOME_DIR_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>homeDir</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_LAST_LOGOFF_PARMNUM"><CODE>USER_LAST_LOGOFF_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>lastLogoff</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_LAST_LOGON_PARMNUM"><CODE>USER_LAST_LOGON_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>lastLogon</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_LOGON_HOURS_PARMNUM"><CODE>USER_LOGON_HOURS_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>logonHours</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_LOGON_SERVER_PARMNUM"><CODE>USER_LOGON_SERVER_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>logonServer</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_MAX_STORAGE_PARMNUM"><CODE>USER_MAX_STORAGE_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>maxStorage</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_NAME_PARMNUM"><CODE>USER_NAME_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>name</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_NUM_LOGONS_PARMNUM"><CODE>USER_NUM_LOGONS_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>numLogons</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_PARMS_PARMNUM"><CODE>USER_PARMS_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>parms</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_PASSWORD_AGE_PARMNUM"><CODE>USER_PASSWORD_AGE_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>passwordAge</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_PASSWORD_PARMNUM"><CODE>USER_PASSWORD_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>password</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_PRIMARY_GROUP_PARMNUM"><CODE>USER_PRIMARY_GROUP_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
 <CODE>primaryGroup</CODE> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_PRIV_PARMNUM">USER_PRIV_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_priv">priv</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_PROFILE_PARMNUM">USER_PROFILE_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_profile">profile</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_SCRIPT_PATH_PARMNUM">USER_SCRIPT_PATH_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_scriptPath">scriptPath</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_UNITS_PER_WEEK_PARMNUM">USER_UNITS_PER_WEEK_PARMNUM()</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_USER_PRIV_PARMNUM"><CODE>USER_PRIV_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>priv</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_PROFILE_PARMNUM"><CODE>USER_PROFILE_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>profile</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_SCRIPT_PATH_PARMNUM"><CODE>USER_SCRIPT_PATH_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>scriptPath</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_UNITS_PER_WEEK_PARMNUM"><CODE>USER_UNITS_PER_WEEK_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
 <CODE>unitPerWeek</CODE> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_USR_COMMENT_PARMNUM">USER_USR_COMMENT_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_usrComment">usrComment</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_USER_WORKSTATIONS_PARMNUM">USER_WORKSTATIONS_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_workstations">workstations</A> field was absent or not correctly specified.
-
-</DL>
-<P>
-<HR>
-<H1><A NAME="GROUP_INFO_LEVELS">GROUP INFO LEVELS</A></H1>
-<P>
-Some of the <CODE>Group*()</CODE> functions take a <A HREF="#item_level">level</A> parameter. This <A HREF="#item_level">level</A>
-specifies how much detail the corresponding <A HREF="#item_hash">hash</A> should contain (or in the case of a <CODE>GroupGetInfo()</CODE> function, will contain after the call). The following <A HREF="#item_level">level</A> descriptions provide information on what fields should be present for a
-given level. See <A HREF="#GROUP_INFO_FIELDS">GROUP INFO FIELDS</A>
-for a description of the fields.
-
+<P></P>
+<DT><STRONG><A NAME="item_USER_USR_COMMENT_PARMNUM"><CODE>USER_USR_COMMENT_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>usrComment</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_USER_WORKSTATIONS_PARMNUM"><CODE>USER_WORKSTATIONS_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>workstations</CODE> field was absent or not correctly specified.
+<P></P></DL>
+<P>
+<HR>
+<H1><A NAME="group info levels">GROUP INFO LEVELS</A></H1>
+<P>Some of the <CODE>Group*()</CODE> functions take a <CODE>level</CODE> parameter. This <CODE>level</CODE>
+specifies how much detail the corresponding <CODE>hash</CODE> should contain (or in
+the case of a <CODE>GroupGetInfo()</CODE> function, will contain after the call).
+The following <CODE>level</CODE> descriptions provide information on what fields
+should be present for a given level. See <A HREF="#group info fields">GROUP INFO FIELDS</A>
+for a description of the fields.</P>
 <DL>
-<DT><STRONG>Level 0</STRONG><DD>
-<P>
+<DT><STRONG><CODE>Level 0</CODE></STRONG><BR>
+<DD>
 name.
-
-<DT><STRONG>Level 1</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><CODE>Level 1</CODE></STRONG><BR>
+<DD>
 name, comment.
-
-<DT><STRONG>Level 2</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><CODE>Level 2</CODE></STRONG><BR>
+<DD>
 name, comment, groupId, attributes.
-
-<DT><STRONG>Level 1002</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><A NAME="item_Level_1002"><CODE>Level 1002</CODE></A></STRONG><BR>
+<DD>
 comment.
-
-<DT><STRONG>Level 1005</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><CODE>Level 1005</CODE></STRONG><BR>
+<DD>
 attributes.
-
-</DL>
+<P></P></DL>
 <P>
 <HR>
-<H1><A NAME="GROUP_INFO_FIELDS">GROUP INFO FIELDS</A></H1>
+<H1><A NAME="group info fields">GROUP INFO FIELDS</A></H1>
 <DL>
-<DT><STRONG><A NAME="item_attributes">attributes - Scalar Int</A></STRONG><DD>
-<P>
+<DT><STRONG><A NAME="item_attributes_%2D_Scalar_Int"><CODE>attributes</CODE> - Scalar Int</A></STRONG><BR>
+<DD>
 The attributes of the group. These are no longer settable in Windows NT 4.0
 and they are not currently supported in this package either.
-
-<DT><STRONG>comment - Scalar String</STRONG><DD>
-<P>
-The <A HREF="#item_comment">comment</A> that applies to this group. This is the only value that can be set via a
-GroupSetInfo call.
-
-<DT><STRONG><A NAME="item_groupId">groupId - Scalar Int</A></STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><CODE>comment</CODE> - Scalar String</STRONG><BR>
+<DD>
+The <CODE>comment</CODE> that applies to this group. This is the only value that
+can be set via a GroupSetInfo call.
+<P></P>
+<DT><STRONG><A NAME="item_groupId_%2D_Scalar_Int"><CODE>groupId</CODE> - Scalar Int</A></STRONG><BR>
+<DD>
 The groups Id.
-
-<DT><STRONG>name - Scalar String</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><CODE>name</CODE> - Scalar String</STRONG><BR>
+<DD>
 The groups name.
-
-</DL>
+<P></P></DL>
 <P>
 <HR>
-<H1><A NAME="GROUP_FIELD_ERRORS">GROUP FIELD ERRORS</A></H1>
-<P>
-For the <CODE>Group*()</CODE> functions that take an <A HREF="#item_error">error</A> parameter this variable will, on failure, contain one of the following
-constants. Note that the function may fail because more than one key/value
-was missing from the input hash. You will only find out about the first one
+<H1><A NAME="group field errors">GROUP FIELD ERRORS</A></H1>
+<P>For the <CODE>Group*()</CODE> functions that take an <CODE>error</CODE> parameter
+this variable will, on failure, contain one of the following constants.
+Note that the function may fail because more than one key/value was
+missing from the input hash. You will only find out about the first one
 that was incorrectly specified. This is only really useful for debugging
-purposes.
-
+purposes.</P>
 <DL>
-<DT><STRONG><A NAME="item_GROUP_ATTRIBUTES_PARMNUM">GROUP_ATTRIBUTES_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_attributes">attributes</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_GROUP_COMMENT_PARMNUM">GROUP_COMMENT_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_comment">comment</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_GROUP_NAME_PARMNUM">GROUP_NAME_PARMNUM()</A></STRONG><DD>
-<P>
-<A HREF="#item_name">name</A> field was absent or not correctly specified.
-
-</DL>
-<P>
-<HR>
-<H1><A NAME="GROUP_USERS_INFO_LEVELS">GROUP USERS INFO LEVELS</A></H1>
-<P>
-The <CODE>GroupGetUsers()</CODE> function can take a level of 0 or 1. These will return the following:
-
+<DT><STRONG><A NAME="item_GROUP_ATTRIBUTES_PARMNUM"><CODE>GROUP_ATTRIBUTES_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>attributes</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_GROUP_COMMENT_PARMNUM"><CODE>GROUP_COMMENT_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>comment</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_GROUP_NAME_PARMNUM"><CODE>GROUP_NAME_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+<CODE>name</CODE> field was absent or not correctly specified.
+<P></P></DL>
+<P>
+<HR>
+<H1><A NAME="group users info levels">GROUP USERS INFO LEVELS</A></H1>
+<P>The <CODE>GroupGetUsers()</CODE> function can take a level of 0 or 1. These will
+return the following:</P>
 <DL>
-<DT><STRONG>Level 0</STRONG><DD>
-<P>
+<DT><STRONG><CODE>Level 0</CODE></STRONG><BR>
+<DD>
 name.
-
-<DT><STRONG>Level 1</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><CODE>Level 1</CODE></STRONG><BR>
+<DD>
 name, attributes.
-
-</DL>
+<P></P></DL>
 <P>
 <HR>
-<H1><A NAME="GROUP_USERS_INFO_FIELDS">GROUP USERS INFO FIELDS</A></H1>
+<H1><A NAME="group users info fields">GROUP USERS INFO FIELDS</A></H1>
 <DL>
-<DT><STRONG>name - Scalar String</STRONG><DD>
-<P>
+<DT><STRONG><CODE>name</CODE> - Scalar String</STRONG><BR>
+<DD>
 The user's name.
-
-<DT><STRONG>attributes - Scalar Int</STRONG><DD>
-<P>
-The attributes of the group. These are no longer settable in Windows NT 4.0
-and they are not currently supported in this package either.
-
-</DL>
+<P></P>
+<DT><STRONG><CODE>attributes</CODE> - Scalar Int</STRONG><BR>
+<DD>
+The attributes of the group. These are no longer settable in Windows NT
+4.0 and they are not currently supported in this package either.
+<P></P></DL>
 <P>
 <HR>
-<H1><A NAME="LOCAL_GROUP_INFO_LEVELS">LOCAL GROUP INFO LEVELS</A></H1>
+<H1><A NAME="local group info levels">LOCAL GROUP INFO LEVELS</A></H1>
 <DL>
-<DT><STRONG>Level 0</STRONG><DD>
-<P>
+<DT><STRONG><CODE>Level 0</CODE></STRONG><BR>
+<DD>
 name
-
-<DT><STRONG>Level 1</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><CODE>Level 1</CODE></STRONG><BR>
+<DD>
 name, comment
-
-<DT><STRONG>Level 1002</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><CODE>Level 1002</CODE></STRONG><BR>
+<DD>
 comment
-
-</DL>
+<P></P></DL>
 <P>
 <HR>
-<H1><A NAME="LOCAL_GROUP_INFO_FIELDS">LOCAL GROUP INFO FIELDS</A></H1>
+<H1><A NAME="local group info fields">LOCAL GROUP INFO FIELDS</A></H1>
 <DL>
-<DT><STRONG>name - Scalar String</STRONG><DD>
-<P>
+<DT><STRONG><CODE>name</CODE> - Scalar String</STRONG><BR>
+<DD>
 The groups name
-
-<DT><STRONG>comment - Scalar String</STRONG><DD>
-<P>
+<P></P>
+<DT><STRONG><CODE>comment</CODE> - Scalar String</STRONG><BR>
+<DD>
 The groups 'comment'
-
-</DL>
-<P>
-<HR>
-<H1><A NAME="LOCAL_GROUP_FIELD_ERRORS">LOCAL GROUP FIELD ERRORS</A></H1>
-<P>
-For the <CODE>LocalGroup*()</CODE> functions that take an <A HREF="#item_error">error</A> parameter this variable will, on failure, contain one of the following
-constants. Note that the function may fail because more than one key/value
-was missing or incorrectly specified in the input hash. You will only find
-out about the first one that was incorrectly specified. This is only really
-useful for debugging purposes.
-
-<DL>
-<DT><STRONG><A NAME="item_LOCALGROUP_NAME_PARMNUM">LOCALGROUP_NAME_PARMNUM()</A></STRONG><DD>
-<P>
-The <A HREF="#item_name">name</A> field was absent or not correctly specified.
-
-<DT><STRONG><A NAME="item_LOCALGROUP_COMMENT_PARMNUM">LOCALGROUP_COMMENT_PARMNUM()</A></STRONG><DD>
-<P>
-The <A HREF="#item_comment">comment</A> field wasabsent or not correctly specified.
-
-</DL>
+<P></P></DL>
 <P>
 <HR>
-<H1><A NAME="EXAMPLES">EXAMPLES</A></H1>
-<P>
-The following example shows how you can create a function in Perl that has
-the same functionality as the <CODE>NetUserEnum()</CODE> API call. The Perl version doesn't have the level parameter so you must
-first use the
-<CODE>UserEnum()</CODE> function to retrieve all the account names and then iterate through the
-returned array issuing <CODE>UserGetInfo()</CODE> calls.
-
-<P>
-<PRE>    sub userEnumAtLevel {
+<H1><A NAME="local group field errors">LOCAL GROUP FIELD ERRORS</A></H1>
+<P>For the <CODE>LocalGroup*()</CODE> functions that take an <CODE>error</CODE> parameter this
+variable will, on failure, contain one of the following constants. Note
+that the function may fail because more than one key/value was missing
+or incorrectly specified in the input hash. You will only find out about
+the first one that was incorrectly specified. This is only really useful
+for debugging purposes.</P>
+<DL>
+<DT><STRONG><A NAME="item_LOCALGROUP_NAME_PARMNUM"><CODE>LOCALGROUP_NAME_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+The <CODE>name</CODE> field was absent or not correctly specified.
+<P></P>
+<DT><STRONG><A NAME="item_LOCALGROUP_COMMENT_PARMNUM"><CODE>LOCALGROUP_COMMENT_PARMNUM()</CODE></A></STRONG><BR>
+<DD>
+The <CODE>comment</CODE> field wasabsent or not correctly specified.
+<P></P></DL>
+<P>
+<HR>
+<H1><A NAME="examples">EXAMPLES</A></H1>
+<P>The following example shows how you can create a function in Perl that
+has the same functionality as the <CODE>NetUserEnum()</CODE> API call. The Perl
+version doesn't have the level parameter so you must first use the
+<CODE>UserEnum()</CODE> function to retrieve all the account names and then iterate
+through the returned array issuing <CODE>UserGetInfo()</CODE> calls.</P>
+<PRE>
+    sub userEnumAtLevel {
        my($server, $level, $filter) = @_;
        my(@array);
        Win32API::Net::UserEnum($server, \@array, $filter);
@@ -1757,35 +1566,25 @@
           print &quot;This could access all level $level settings for $user - eg fullName $hash{fullName}\n&quot;;
        }
     }
-    userEnumAtLevel(&quot;&quot;, 2, 0);
-</PRE>
+    userEnumAtLevel(&quot;&quot;, 2, 0);</PRE>
 <P>
 <HR>
-<H1><A NAME="AUTHOR">AUTHOR</A></H1>
-<P>
-Bret Giddings, &lt;<A
-HREF="mailto:bret@essex.ac.uk">bret@essex.ac.uk</A>&gt;
-
+<H1><A NAME="author">AUTHOR</A></H1>
+<P>Bret Giddings, &lt;<A HREF="mailto:bret@essex.ac.uk">bret@essex.ac.uk</A>&gt;</P>
 <P>
 <HR>
-<H1><A NAME="SEE_ALSO">SEE ALSO</A></H1>
-<P>
-<CODE>perl(1)</CODE>
-
-
-
+<H1><A NAME="see also">SEE ALSO</A></H1>
+<P><CODE>perl(1)</CODE></P>
 <P>
 <HR>
-<H1><A NAME="ACKNOWEDGEMENTS">ACKNOWEDGEMENTS</A></H1>
-<P>
-This work was built upon work done by HiP Communications along with
-modifications to HiPs code by &lt;<A
-HREF="mailto:michael@ecel.uwa.edu.au">michael@ecel.uwa.edu.au</A>&gt; and
-&lt;<A HREF="mailto:rothd@roth.net">rothd@roth.net</A>&gt; In addition, I
-would like to thank Jenny Emby at GEC Marconi, U.K. for proof reading this
-manual page and making many suggestions that have led to its current
-layout. Last but not least I would like to thank Larry Wall and all the
-other Perl contributors for making this truly wonderful language.
+<H1><A NAME="acknowedgements">ACKNOWEDGEMENTS</A></H1>
+<P>This work was built upon work done by HiP Communications along with
+modifications to HiPs code by &lt;<A HREF="mailto:michael@ecel.uwa.edu.au">michael@ecel.uwa.edu.au</A>&gt; and &lt;<A HREF="mailto:rothd@roth.net">rothd@roth.net</A>&gt;.
+In addition, I would like to thank Jenny Emby at GEC Marconi, U.K. for
+proof reading this manual page and making many suggestions that have led
+to its current layout. Last but not least I would like to thank Larry Wall
+and all the other Perl contributors for making this truly wonderful
+language.</P>
 
 </BODY>
 
diff -urN libwin32-0.171/APINet/Net.pm libwin32-0.172/APINet/Net.pm
--- libwin32-0.171/APINet/Net.pm	Mon May 14 00:12:25 2001
+++ libwin32-0.172/APINet/Net.pm	Mon May 14 00:14:08 2001
@@ -64,7 +64,7 @@
 }
 $EXPORT_TAGS{ALL}= \@EXPORT_OK;
 
-$VERSION = '0.081';
+$VERSION = '0.09';
 
 sub AUTOLOAD {
     my $constname;
@@ -219,7 +219,7 @@
 L<USER INFO FIELDS> for more information on what these represent.
 
 
-=head1 Exports
+=head1 EXPORTS
 
 By default, Win32API::Net exports no symbols into the callers namespace.
 The following tags can be used to selectively import symbols into the
@@ -992,7 +992,7 @@
 
 =head2 GetDCName(server, domain, domain-controller)
 
-Gets the C<domain-controllder> name for C<server> and C<domain>.
+Gets the C<domain-controller> name for C<server> and C<domain>.
 
 =over 8
 
@@ -1747,7 +1747,6 @@
 The groups 'comment'
 
 =back
-
 
 =head1 LOCAL GROUP FIELD ERRORS
 
diff -urN libwin32-0.171/APINet/Net.xs libwin32-0.172/APINet/Net.xs
--- libwin32-0.171/APINet/Net.xs	Mon May 14 00:12:25 2001
+++ libwin32-0.172/APINet/Net.xs	Mon May 14 00:14:08 2001
@@ -926,7 +926,7 @@
 	    sv = newSViv((BYTE)(((CAST)uiX)->field)[i++]);		\
 	    av_push(av, sv);						\
 	}								\
-	hv_store((HV*)hv, name, strlen(name), newRV_inc((SV*)av), 0);	\
+	hv_store((HV*)hv, name, strlen(name), newRV_noinc((SV*)av), 0);	\
     } STMT_END
 
 void
diff -urN libwin32-0.171/APINet/t/test.t libwin32-0.172/APINet/t/test.t
--- libwin32-0.171/APINet/t/test.t	Mon May 14 00:12:25 2001
+++ libwin32-0.172/APINet/t/test.t	Mon May 14 00:14:08 2001
@@ -49,7 +49,7 @@
 @testLogonHours=( 255 ) x 21;
 %testUserInfo3=(
 	'name'          => $testUserName,
-	'password'      => "",							# don't worry - the account is disabled
+	'password'      => "password",							# don't worry - the account is disabled
 	'passwordAge'   => 0,
 	'priv'          => USER_PRIV_USER(),
 	'homeDir'       => $ENV{'TEMP'},
@@ -82,7 +82,7 @@
 # this will fail if this account actually exists - this is a good thing.
 $fie=0;
 UserAdd($dc, 3, \%testUserInfo3, $fie) or die <<EOM;
-not ok 4
+not ok 5
 Can't add a user so there really isn't any point in continuing...
 EOM
 print "ok 5\n";
diff -urN libwin32-0.171/APIRegistry/test.pl libwin32-0.172/APIRegistry/test.pl
--- libwin32-0.171/APIRegistry/test.pl	Mon May 14 00:12:25 2001
+++ libwin32-0.172/APIRegistry/test.pl	Mon May 14 00:14:08 2001
@@ -19,7 +19,7 @@
 
 $|= 1   if  $Debug= ( -t STDIN ) != ( -t STDOUT );
 
-$zero= 16;	# Change to 0 when RegEnumKeyExA() and RegEnumValueA()
+$zero= 0;	# Change to 0 when RegEnumKeyExA() and RegEnumValueA()
 		# handle ERROR_MORE_DATA better!
 
 $ok= RegQueryInfoKey( HKEY_LOCAL_MACHINE, $class, $clen=0, [],
@@ -201,8 +201,9 @@
 $Debug && $@ && warn "# \$@=$@\n";
 print $ok ? "" : "not ", "ok 26\n";
 
-$ok=  ! eval { InitiateSystemShutdown([],[],0,0,0) }  &&  $@ eq "";
-$Debug && $@ && warn "# \$@=$@\n";
+$ok= 1;
+#$ok=  ! eval { InitiateSystemShutdown([],[],0,0,0) }  &&  $@ eq "";
+#$Debug && $@ && warn "# \$@=$@\n";
 print $ok ? "" : "not ", "ok 27\n";
 
 $ok=  ! eval { RegCloseKey(0) }  &&  $@ eq "";
diff -urN libwin32-0.171/Console/test.pl libwin32-0.172/Console/test.pl
--- libwin32-0.171/Console/test.pl	Mon May 14 00:12:26 2001
+++ libwin32-0.172/Console/test.pl	Mon May 14 00:14:09 2001
@@ -1,3 +1,5 @@
+#these tests are useless in the automated build process
+exit if $ENV{ACTIVEPERL_SKIP_INTERACTIVE_TESTS};
 
 use Win32::Console;
 
diff -urN libwin32-0.171/Internet/test.pl libwin32-0.172/Internet/test.pl
--- libwin32-0.171/Internet/test.pl	Mon May 14 00:12:26 2001
+++ libwin32-0.172/Internet/test.pl	Mon May 14 00:14:11 2001
@@ -223,6 +223,9 @@
 ##############################################################################
 # HTTP STUFF
 
+exit; # 25Aug2000 Jan Dubois
+# Dada's server is often unavailalble, so we skip these test for the time being
+
 $host = "www.divinf.it";
 $user = "anonymous";
 $pass = "dada\@divinf.it";
diff -urN libwin32-0.171/MANIFEST libwin32-0.172/MANIFEST
--- libwin32-0.171/MANIFEST	Mon May 14 00:12:26 2001
+++ libwin32-0.172/MANIFEST	Mon May 14 00:14:11 2001
@@ -157,6 +157,7 @@
 ODBC/ODBC.pm
 ODBC/ODBC.xs
 ODBC/ODBCbuild.h
+ODBC/ODBCTEST.MDB
 ODBC/Odbc.rc
 ODBC/README.TXT
 ODBC/ROADMAP.TXT
diff -urN libwin32-0.171/NetAdmin/t/netadmin.t libwin32-0.172/NetAdmin/t/netadmin.t
--- libwin32-0.171/NetAdmin/t/netadmin.t	Mon May 14 00:12:26 2001
+++ libwin32-0.172/NetAdmin/t/netadmin.t	Mon May 14 00:14:12 2001
@@ -14,7 +14,7 @@
 
 $serverName = '';
 $userName = 'TestUser';
-$password = '';
+$password = 'password';
 $passwordAge = 0;
 $privilege = USER_PRIV_USER;
 $homeDir = 'c:\\';
@@ -24,21 +24,18 @@
 $groupName = 'TestGroup';
 $groupComment = "This is a test group";
 
-print "1..16\n";
+print "1..15\n";
 
 # TODO: Check to make sure current account has rights to Create user accounts etc.
 
 Win32::NetAdmin::UserCreate($serverName, $userName, $password, $passwordAge, $privilege, $homeDir, $comment, $flags, $scriptpath) || print "not ";
 print "ok 1\n";
 
-Win32::NetAdmin::UserGetAttributes($serverName, $userName, $Getpassword, $GetpasswordAge, $Getprivilege, $GethomeDir, $Getcomment, $Getflags, $Getscriptpath) || print "not ";
+Win32::NetAdmin::UserGetAttributes($serverName, $userName, my $getpassword, $GetpasswordAge, $Getprivilege, $GethomeDir, $Getcomment, $Getflags, $Getscriptpath) || print "not ";
 print "ok 2\n";
 
-($password eq $Getpassword) || print "not ";
-print "ok 3\n";
-
 ($passwordAge == $GetpasswordAge) || print "not ";
-print "ok 4\n";
+print "ok 3\n";
 
 if($serverName eq '')
 {
@@ -49,38 +46,38 @@
 {
 	($privilege == $Getprivilege) || print "not ";
 }
-print "ok 5\n";
+print "ok 4\n";
 
 ($homeDir eq $GethomeDir) || print "not ";
-print "ok 6\n";
+print "ok 5\n";
 
 ($comment eq $Getcomment) || print "not ";
-print "ok 7\n";
+print "ok 6\n";
 
 ($flags == ($Getflags&USER_PRIV_MASK)) || print "not ";
-print "ok 8\n";
+print "ok 7\n";
 
 ($scriptpath eq $Getscriptpath) || print "not ";
-print "ok 9\n";
+print "ok 8\n";
 
 Win32::NetAdmin::LocalGroupCreate($serverName, $groupName, $groupComment) || print "not ";
-print "ok 10\n";
+print "ok 9\n";
 
 Win32::NetAdmin::LocalGroupGetAttributes($serverName, $groupName, $GetgroupComment) || print "not ";
-print "ok 11\n";
+print "ok 10\n";
 
 ($groupComment eq $GetgroupComment) || print "not ";
-print "ok 12\n";
+print "ok 11\n";
 
 Win32::NetAdmin::LocalGroupAddUsers($serverName, $groupName, $userName) || print "not ";
-print "ok 13\n";
+print "ok 12\n";
 
 Win32::NetAdmin::LocalGroupIsMember($serverName, $groupName, $userName) || print "not ";
-print "ok 14\n";
+print "ok 13\n";
 
 Win32::NetAdmin::LocalGroupDelete($serverName, $groupName) || print "not ";
-print "ok 15\n";
+print "ok 14\n";
 
 Win32::NetAdmin::UserDelete($serverName, $userName) || print "not ";
-print "ok 16\n";
+print "ok 15\n";
 
diff -urN libwin32-0.171/NetResource/Changes libwin32-0.172/NetResource/Changes
--- libwin32-0.171/NetResource/Changes	Mon May 14 00:12:26 2001
+++ libwin32-0.172/NetResource/Changes	Mon May 14 00:14:12 2001
@@ -1,5 +1,10 @@
 Revision history for Perl extension Win32::NetResource.
 
+0.051 (unreleased)
+	- NetShareGetInfo() didn't work when passed a hashref as \%share
+	- pointers to various stack variables were being used outside
+	  their scope
+
 0.05  Mon Jun 23 11:01:23 1999
 	- allow GetSharedResources() to continue when there are
 	  "Access denied" errors; it also returns resources seen
diff -urN libwin32-0.171/NetResource/NetResource.pm libwin32-0.172/NetResource/NetResource.pm
--- libwin32-0.171/NetResource/NetResource.pm	Mon May 14 00:12:26 2001
+++ libwin32-0.172/NetResource/NetResource.pm	Mon May 14 00:14:12 2001
@@ -4,7 +4,7 @@
 require DynaLoader;
 require AutoLoader;
 
-$VERSION = '0.05';
+$VERSION = '0.051';
 
 @ISA = qw(Exporter DynaLoader);
 # Items to export into callers namespace by default. Note: do not export
@@ -323,7 +323,7 @@
 {
     my ($netinfo,$val);
     $val = _NetShareGetInfo( $_[0],$netinfo,$_[2] || "");
-    $_[1] = _SHARE2hash( $netinfo );    
+    %{$_[1]} = %{_SHARE2hash( $netinfo )};    
     $val;
 }
 
diff -urN libwin32-0.171/NetResource/NetResource.xs libwin32-0.172/NetResource/NetResource.xs
--- libwin32-0.171/NetResource/NetResource.xs	Mon May 14 00:13:10 2001
+++ libwin32-0.172/NetResource/NetResource.xs	Mon May 14 00:14:12 2001
@@ -425,10 +425,11 @@
 GetConnection(LocalName,RemoteName)
     LPCSTR    LocalName
     LPCSTR    RemoteName = NO_INIT
+PREINIT:
+    BYTE szRemote[4192];
 CODE:
     {
-        BYTE szRemote[4192];
-        DWORD cbBuffer = sizeof(szRemote);
+	DWORD cbBuffer = sizeof(szRemote);
         dwLastError = WNetGetConnectionA(LocalName,(char*)szRemote,&cbBuffer);
         RETVAL = (dwLastError == NO_ERROR);
         if (!RETVAL)
@@ -446,9 +447,10 @@
     DWORD    ErrorCode = NO_INIT
     LPCSTR    Description    = NO_INIT
     LPCSTR    Name = NO_INIT
-CODE:
+PREINIT:
     BYTE    abDesc[2048];
     BYTE    abName[2048];
+CODE:
     DWORD   cbDesc = sizeof(abDesc);
     DWORD   cbName = sizeof(abName);
     dwLastError = WNetGetLastErrorA(&ErrorCode,(char *)abDesc,cbDesc,(char *)abName,cbName);
@@ -480,9 +482,10 @@
 GetUNCName(UNCName,LocalPath)
     LPCSTR UNCName = NO_INIT
     LPCSTR    LocalPath
+PREINIT:
+    UNIVERSAL_NAME_INFO   uniBuffer[1024];
 CODE:
     {
-        UNIVERSAL_NAME_INFO   uniBuffer[1024];
         DWORD    BufferSize = sizeof(uniBuffer);
         
         dwLastError = WNetGetUniversalNameA(LocalPath,UNIVERSAL_NAME_INFO_LEVEL,uniBuffer,&BufferSize);
@@ -502,9 +505,10 @@
     PTSHARE_INFO    tshare
     LPDWORD parm_err     
     LPSTR servername
+PREINIT:
+    DWORD    parm;
 CODE:
     {
-        DWORD    parm;
         SHARE_INFO_502     Share_502;
         LPWSTR    lpwServer;
         AllocWideName( servername,lpwServer );
@@ -589,10 +593,11 @@
     LPSTR netname
     PTSHARE_INFO ReturnInfo = NO_INIT
     LPSTR servername
+PREINIT:
+    TSHARE_INFO    tRet;    
 CODE:
     {
         BOOL bRet;
-        TSHARE_INFO    tRet;    
         PSHARE_INFO_502    pShareInfo;
         LPWSTR    lpwServer,lpwNetname;
 
diff -urN libwin32-0.171/NetResource/t/netresource.t libwin32-0.172/NetResource/t/netresource.t
--- libwin32-0.171/NetResource/t/netresource.t	Mon May 14 00:12:26 2001
+++ libwin32-0.172/NetResource/t/netresource.t	Mon May 14 00:14:12 2001
@@ -118,22 +118,27 @@
     $myRef = $href if $href->{'RemoteName'} =~ /PerlTempShare/;
 }
 
-$drive = Win32::GetNextAvailDrive();
 #$drive = 'I:';
-$myRef->{'LocalName'} = $drive;
-#print STDERR "mapping to |$drive|\n", Dumper($myRef), "\n";
-Win32::NetResource::AddConnection($myRef,$passwd,$user,0);
-err();
-
-Win32::NetResource::GetUNCName( $UNCName, $drive ) or print "not ";
-print "ok 5\n";
-err();
-deb("uncname is $UNCName");
+$drive = Win32::GetNextAvailDrive();
+deb("drive is $drive");
+if (keys %$myRef) {
+    $myRef->{'LocalName'} = $drive;
+    #print STDERR "mapping to |$drive|\n", Dumper($myRef), "\n";
+    Win32::NetResource::AddConnection($myRef,$passwd,$user,0);
+    err();
 
-Win32::NetResource::CancelConnection($drive,0,1) or print "not ";
-print "ok 6\n";
-err();
+    Win32::NetResource::GetUNCName( $UNCName, $drive ) or print "not ";
+    print "ok 5\n";
+    err();
+    deb("uncname is $UNCName");
 
+    Win32::NetResource::CancelConnection($drive,0,1) or print "not ";
+    print "ok 6\n";
+    err();
+}
+else {
+    print "ok $_ # skipped: share not found\n" for 5..6;
+}
 Win32::NetResource::NetShareDel("PerlTempShare") or print "not ";
 print "ok 7\n";
 err();
diff -urN libwin32-0.171/ODBC/MANIFEST libwin32-0.172/ODBC/MANIFEST
--- libwin32-0.171/ODBC/MANIFEST	Mon May 14 00:12:26 2001
+++ libwin32-0.172/ODBC/MANIFEST	Mon May 14 00:14:12 2001
@@ -12,6 +12,7 @@
 ODBC.pm
 ODBC.xs
 ODBCbuild.h
+ODBCTEST.MDB
 Odbc.rc
 README.TXT
 ROADMAP.TXT
diff -urN libwin32-0.171/OLE/Changes libwin32-0.172/OLE/Changes
--- libwin32-0.171/OLE/Changes	Mon May 14 00:13:10 2001
+++ libwin32-0.172/OLE/Changes	Mon May 14 00:14:14 2001
@@ -3,6 +3,24 @@
 Changes in version 0.01-0.03 are by Gurusamy Sarathy. All other changes
 are by Jan Dubois unless attributed otherwise.
 
+0.1501	unreleased
+	- Don't clobber $1 etc. in AUTOLOAD.  Unfortunately Perl doesn't set
+	  POK on the $1 SV, so we still cannot pass it to OLE methods. :(
+
+0.15	Wed, December 6th, 2000
+	- Make sure the OLE browser works with IE5.5 and the latest ActivePerl
+	- Relax the checks for file existance in Win32::OLE::Const
+
+0.1403	Tue, November 21st, 2000
+	- Win32::OLE::Const: ignore non-existant typelibs (by Richard Letts)
+	- safeguard against access violation in Dispatch()
+	- Work around perl_call_sv() bug in ReportOleError(); use G_EVAL and
+	  rethrow the exception to get the runlevel right
+
+0.1402	Mon, September 25th, 2000
+	- Fix potential crash during global cleanup when _Unique is set
+	  (by Rudi Farkas <rudolf.farkas@lecroy.com>)
+
 0.1401	Mon, September 11th, 2000
 	- fix bug in GetMultiByteEx() sometimes chopping off the last byte
 
diff -urN libwin32-0.171/OLE/OLE.xs libwin32-0.172/OLE/OLE.xs
--- libwin32-0.171/OLE/OLE.xs	Mon May 14 00:13:10 2001
+++ libwin32-0.172/OLE/OLE.xs	Mon May 14 00:14:16 2001
@@ -64,7 +64,7 @@
 #undef WORD
 typedef unsigned short WORD;
 
-#if PATCHLEVEL < 6
+#if PERL_VERSION < 6
 #   error Win32::OLE requires Perl 5.6.0 or later
 #endif
 
@@ -864,10 +864,24 @@
     }
 
     if (cv) {
+        ENTER;
+        SAVETMPS;
         PUSHMARK(sp);
         XPUSHs(sv);
         PUTBACK;
-        perl_call_sv((SV*)cv, G_DISCARD);
+        perl_call_sv((SV*)cv, G_DISCARD|G_EVAL);
+        FREETMPS;
+        LEAVE;
+        if (SvTRUE(ERRSV)) {
+#if defined(ACTIVEPERL_CHANGELIST) || (PERL_VERSION > 6 || PERL_SUBVERSION > 0)
+            if (sv_isobject(ERRSV))
+                croak(Nullch); /* rethrow exception */
+            else
+                croak("%s", SvPV_nolen(ERRSV));
+#else
+            croak("%s", SvPV_nolen(ERRSV));
+#endif
+        }
     }
 
 }   /* ReportOleError */
@@ -1052,7 +1066,7 @@
 	ENTER;
 	if (SvPOK(pObj->destroy)) {
 	    /* $self->Dispatch($destroy,$retval); */
-	    EXTEND(sp, 3);
+	    EXTEND(SP, 3);
 	    PUSHMARK(sp);
 	    PUSHs(self);
 	    PUSHs(pObj->destroy);
@@ -1074,15 +1088,6 @@
 	pObj->destroy = NULL;
     }
 
-    if (pObj->flags & OBJFLAG_UNIQUE) {
-        dPERINTERP;
-        IUnknown *punk; // XXX check error?
-        pObj->pDispatch->QueryInterface(IID_IUnknown, (void**)&punk);
-        hv_delete(g_hv_unique, (char*)&punk, sizeof(punk), G_DISCARD);
-        DBG((" hv_delete(%08x)", punk));
-        punk->Release();
-    }
-
     if (pObj->pEventSink) {
 	DBG((" Unadvise connection |%lx|", pObj));
 	pObj->pEventSink->Unadvise();
@@ -1090,6 +1095,14 @@
     }
 
     if (pObj->pDispatch) {
+        if (pObj->flags & OBJFLAG_UNIQUE) {
+            dPERINTERP;
+            IUnknown *punk; // XXX check error?
+            pObj->pDispatch->QueryInterface(IID_IUnknown, (void**)&punk);
+            hv_delete(g_hv_unique, (char*)&punk, sizeof(punk), G_DISCARD);
+            DBG((" hv_delete(%08x)", punk));
+            punk->Release();
+        }
 	DBG((" Release pDispatch"));
 	pObj->pDispatch->Release();
 	pObj->pDispatch = NULL;
@@ -2193,7 +2206,7 @@
     CV *cv = perl_get_cv("Win32::COM::GUID::new", FALSE);
 
     if (cv) {
-	EXTEND(sp, 2);
+	EXTEND(SP, 2);
 	PUSHMARK(sp);
 	PUSHs(sv_2mortal(newSVpv("Win32::COM::GUID", 0)));
 	PUSHs(sv_2mortal(newSVpv((char*)&rguid, sizeof(GUID))));
@@ -3223,7 +3236,7 @@
      * the method name and return value.
      */
     PUSHMARK(mark);
-    EXTEND(sp,2);
+    EXTEND(SP, 2);
     for (I32 item = 1; item < items; ++item)
 	ST(2+items-item) = ST(items-item);
     sp += 2;
@@ -3713,7 +3726,7 @@
 	sv_catpvf(err, " \"%s\"", buffer);
 
 	if (hr == DISP_E_TYPEMISMATCH || hr == DISP_E_PARAMNOTFOUND) {
-	    if (argErr < dispParams.cNamedArgs)
+	    if (rghe && argErr < dispParams.cNamedArgs)
 		sv_catpvf(err, " argument \"%s\"",
 			  hv_iterkey(rghe[argErr], &len));
 	    else
@@ -4650,7 +4663,7 @@
 	XSRETURN_EMPTY;
     }
 
-    AV *res = newAV();
+    EXTEND(SP, 5);
 
     // Enumerate all Clsids
     for (DWORD dwClsid=0;; ++dwClsid) {
@@ -4703,7 +4716,7 @@
 		err = RegOpenKeyExW(hKeyClsid, wVersion, 0, KEY_READ, &hKeyVersion);
 		if (err != ERROR_SUCCESS)
 		    continue;
-		
+
 		cbTitle = (sizeof(wTitle)/sizeof(wTitle[0]));
 		err = RegQueryValueW(hKeyVersion, NULL, wTitle, &cbTitle);
 		if (err != ERROR_SUCCESS || cbTitle <= 1)
@@ -4742,7 +4755,7 @@
 				       NULL, NULL, NULL, &ft);
 		    if (err != ERROR_SUCCESS)
 			break;
-		    
+
 		    W2AHELPER(wLangid, szLangid, sizeof(szLangid));
 		    cbLangid = strlen(szLangid);
 		}
@@ -4791,13 +4804,19 @@
 		    err = RegQueryValueA(hKeyLangid, "win32", szFile, &cbFile);
 		}
 		if (err == ERROR_SUCCESS && cbFile > 1) {
-		    AV *av = newAV();
-		    av_push(av, newSVpv(szClsid, cbClsid));
-		    av_push(av, newSVpv(szTitle, cbTitle-1));
-		    av_push(av, newSVpv(szVersion, cbVersion));
-		    av_push(av, newSVpv(szLangid, cbLangid));
-		    av_push(av, newSVpv(szFile, cbFile-1));
-		    av_push(res, newRV_noinc((SV*)av));
+                    ENTER;
+                    SAVETMPS;
+                    PUSHMARK(SP);
+		    PUSHs(sv_2mortal(newSVpv(szClsid, cbClsid)));
+		    PUSHs(sv_2mortal(newSVpv(szTitle, cbTitle-1)));
+		    PUSHs(sv_2mortal(newSVpv(szVersion, cbVersion)));
+		    PUSHs(sv_2mortal(newSVpv(szLangid, cbLangid)));
+		    PUSHs(sv_2mortal(newSVpv(szFile, cbFile-1)));
+                    PUTBACK;
+                    perl_call_pv("Win32::OLE::Const::_Typelib", G_DISCARD);
+                    SPAGAIN;
+                    FREETMPS;
+                    LEAVE;
 		}
 
 		RegCloseKey(hKeyLangid);
@@ -4807,9 +4826,7 @@
 	RegCloseKey(hKeyClsid);
     }
     RegCloseKey(hKeyTypelib);
-
-    ST(0) = sv_2mortal(newRV_noinc((SV*)res));
-    XSRETURN(1);
+    XSRETURN_EMPTY;
 }
 
 void
@@ -6092,7 +6109,7 @@
 
     New(0, pCharType, len, unsigned short);
     if (GetStringTypeA(lcid, type, string, len, pCharType)) {
-	EXTEND(sp, len);
+	EXTEND(SP, len);
 	for (int i=0; i < len; ++i)
 	    PUSHs(sv_2mortal(newSViv(pCharType[i])));
     }
@@ -6105,7 +6122,7 @@
 {
     LANGID langID = GetSystemDefaultLangID();
     if (langID != 0) {
-	EXTEND(sp, 1);
+	EXTEND(SP, 1);
 	XSRETURN_IV(langID);
     }
 }
@@ -6116,7 +6133,7 @@
 {
     LCID lcid = GetSystemDefaultLCID();
     if (lcid != 0) {
-	EXTEND(sp, 1);
+	EXTEND(SP, 1);
 	XSRETURN_IV(lcid);
     }
 }
@@ -6127,7 +6144,7 @@
 {
     LANGID langID = GetUserDefaultLangID();
     if (langID != 0) {
-	EXTEND(sp, 1);
+	EXTEND(SP, 1);
 	XSRETURN_IV(langID);
     }
 }
@@ -6138,7 +6155,7 @@
 {
     LCID lcid = GetUserDefaultLCID();
     if (lcid != 0) {
-	EXTEND(sp, 1);
+	EXTEND(SP, 1);
 	XSRETURN_IV(lcid);
     }
 }
diff -urN libwin32-0.171/OLE/browser/Browser.dhtml libwin32-0.172/OLE/browser/Browser.dhtml
--- libwin32-0.171/OLE/browser/Browser.dhtml	Mon May 14 00:12:26 2001
+++ libwin32-0.172/OLE/browser/Browser.dhtml	Mon May 14 00:14:16 2001
@@ -109,10 +109,11 @@
 # Use the ActivePerl documentation stylesheet for all frames
 # ==========================================================
 
-my $css = "$Config{prefix}\\html\\win32prk.css";
+my $css = "$Config{prefix}\\html\\active.css";
+$css = "$Config{prefix}\\html\\win32prk.css" unless -f $css;
 foreach my $frame (qw(Header Libraries Types Members Footer)) {
     $frame{$frame} = $window->parent->frames($frame);
-    $frame{$frame}->document->createStyleSheet($css);
+    $frame{$frame}->document->createStyleSheet($css) if -f $css;
 }
 
 # Rollon/Rolloff highlighting styles for Libraries, Types and Members
@@ -120,6 +121,7 @@
 
 foreach my $frame (qw(Libraries Types Members)) {
     my $ss = $frame{$frame}->document->createStyleSheet;
+    next unless $ss;
     my $cursor = "cursor: hand";
     $ss->addRule(".Inactive",	    "$cursor; color: black");
     $ss->addRule(".Active",	    "$cursor; color: blue");
@@ -157,21 +159,19 @@
 # =============================
 
 my $html = <<HTML;
-    <TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100%>
-	<TR><TD CLASS=block VALIGN=MIDDLE WIDTH=100% BGCOLOR=#cc0066>
-	    <FONT SIZE=+1 COLOR=#ff99cc><STRONG>&nbsp;
-		Win32::OLE - Type Library Browser
-	    </STRONG></FONT>
-	</TD></TR>
+    <TABLE border="0" cellpadding="0" cellspacing="0" width="100%">
+      <TR><TD class="block" valign="MIDDLE" width="100%" bgcolor="#cccccc">
+          <STRONG><P class="block">&nbsp;Win32::OLE - Type Library Browser</P>
+          </STRONG></TD></TR>
     </TABLE>
 
     <TABLE BORDER=0 CELLPADDING=0>
 	<TR><TD>Show hidden elements:</TD>
 	    <TD><INPUT TYPE="checkbox" $ShowHidden
-		 onclick="parent.Libraries.ShowHidden"></TD></TR>
+		 onclick="parent.Footer.ShowHidden"></TD></TR>
 	<TR><TD>Group elements by type:</TD>
 	    <TD><INPUT TYPE="checkbox" $GroupByType
-		 onclick="parent.Libraries.GroupByType"></TD></TR>
+		 onclick="parent.Footer.GroupByType"></TD></TR>
     </TABLE>
     <HR><FONT SIZE=-2>Written by Jan Dubois in 1999.</FONT>
 HTML
@@ -193,7 +193,7 @@
 # =============================
 
 my $ss = $frame{Footer}->document->createStyleSheet;
-$ss->addRule(".Indented", "margin-left:48; margin-top:0");
+$ss->addRule(".Indented", "margin-left:48; margin-top:0") if $ss;
 undef $ss;
 
 
@@ -214,21 +214,21 @@
 # Create list of type libraries
 # =============================
 
-$html = "<TABLE onhelp=onHelp('Libraries')>\n";
+$html = "<TABLE onhelp=\"parent.Footer.onHelp('Libraries')\">\n";
 for my $id (0..@Library-1) {
     $html .= <<HTML;
     <TR><TD NOWRAP ID=LIB_$id CLASS=Inactive
-	    onclick=selectLibrary()
-	    onmouseover=rollon("Libraries")
-	    onmouseout=rolloff("Libraries")>
+	    onclick="parent.Footer.selectLibrary"
+	    onmouseover="parent.Footer.rollon('Libraries')"
+	    onmouseout="parent.Footer.rolloff('Libraries')">
             <IMG SRC="Library.png" WIDTH=16 HEIGHT=16>
 	    $Library[$id]->[libNAME]</TD>
 	<TD>$Library[$id]->[libMAJOR].$Library[$id]->[libMINOR]</TD></TR>
 HTML
 }
 $html .= "</TABLE>";
-# $frame{Libraries}->document->body->{innerHTML} = $html;
-$window->document->write($html);
+$frame{Libraries}->document->body->{innerHTML} = $html;
+#$window->document->write($html);
 
 # Select a type library and display the types
 # ===========================================
@@ -242,7 +242,7 @@
 my $tlib; # XXX Hack alert!
 
 sub selectLibrary {
-    my $element = $window->event->srcElement;
+    my $element = $frame{Libraries}->event->srcElement;
     $element = $element->parentElement if $element->tagName ne 'TD';
     my ($id) = ($element->id =~ /^LIB_(\d+)/);
     return unless defined $id;
@@ -252,24 +252,28 @@
     $def[0] = quotemeta $def[0];
     my $typelib = Win32::OLE::Const->LoadRegTypeLib(@def);
     if (Win32::OLE->LastError) {
-	$window->alert("Cannot load library: ".Win32::OLE->LastError);
+	$frame{Libraries}->alert("Cannot load library: ".Win32::OLE->LastError);
 	return;
     }
     $tlib = $typelib;
     my $tcount = $tlib->_GetTypeInfoCount;
 
     # Change selection marker
-    $window->document->all("LIB_$Library")->style->{fontWeight} = 'normal'
-	if defined $Library;
+    $frame{Libraries}->document->all("LIB_$Library")->
+	style->{fontWeight} = 'normal' if defined $Library;
     $Library = $id;
-    $window->document->all("LIB_$Library")->style->{fontWeight} = 'bold';
+    $frame{Libraries}->document->all("LIB_$Library")->
+	style->{fontWeight} = 'bold';
 
     # Hide all interfaces mentioned in a COCLASS definition
     my %hide;
     for (0..$tcount-1) {
 	my $tinfo = $tlib->_GetTypeInfo($_);
-	++$hide{$tinfo->_GetImplTypeInfo($_)->_GetTypeAttr->{guid}}
-	  foreach 0..$tinfo->_GetTypeAttr->{cImplTypes}-1;
+	foreach (0..$tinfo->_GetTypeAttr->{cImplTypes}-1) {
+	    my $impltinfo = $tinfo->_GetImplTypeInfo($_);
+	    next unless defined $impltinfo;
+	    ++$hide{$impltinfo->_GetTypeAttr->{guid}};
+	}
     }
 
     # Make a sorted list of all type information
@@ -301,7 +305,7 @@
     $html .= <<HTML if $HelpFile;
 	<IMG SRC="Help.png" WIDTH=16 HEIGHT=16
 	 STYLE="$opaque cursor:hand"
-	 onclick="parent.Libraries.showHelpfile">&nbsp;
+	 onclick="parent.Footer.showHelpfile">&nbsp;
 HTML
     $html .= "Library <B>$doc->{Name}</B>";
     $html .= "<P CLASS=Indented>$doc->{HelpFile}" if HelpFile;
@@ -337,7 +341,7 @@
     } 0..@Type-1;
 
     # Create a table of available types
-    my $html = "<TABLE onhelp=\"parent.Libraries.onHelp('Types')\">\n";
+    my $html = "<TABLE onhelp=\"parent.Footer.onHelp('Types')\">\n";
     foreach (0..@Index-1) {
 	my $id = $Index[$_];
 	my $name = $Type[$id]->[typeDOC]->{Name};
@@ -346,9 +350,9 @@
 	my $hidden = $Type[$id]->[typeHIDDEN] ? 'Hidden' : '';
 	$html .= <<HTML;
 	    <TR><TD NOWRAP ID=TYPE_$id CLASS=Inactive$hidden
-		    onmouseover="parent.Libraries.rollon('Types')"
-		    onmouseout="parent.Libraries.rolloff('Types')"
-		    onclick="parent.Libraries.selectType">
+		    onmouseover="parent.Footer.rollon('Types')"
+		    onmouseout="parent.Footer.rolloff('Types')"
+		    onclick="parent.Footer.selectType">
 		<IMG $src WIDTH=16 HEIGHT=16>$name</TD></TR>
 HTML
     }
@@ -392,8 +396,9 @@
 	for my $impltype (0 .. $Type[$Type]->[typeATTR]->{cImplTypes}-1) {
 	    my $tflags = $tinfo->_GetImplTypeFlags($impltype);
 	    next unless $tflags & IMPLTYPEFLAG_FDEFAULT;
-	    ($tflags & IMPLTYPEFLAG_FSOURCE ? $event : $dispatch) =
-	      $tinfo->_GetImplTypeInfo($impltype);
+	    my $impltinfo = $tinfo->_GetImplTypeInfo($impltype);
+	    next unless defined $impltinfo;
+	    ($tflags & IMPLTYPEFLAG_FSOURCE ? $event : $dispatch) = $impltinfo;
 	}
 	addFunctions($dispatch);
 	addFunctions($event, 'Event');
@@ -461,7 +466,7 @@
     my $html = '';
     $html .= <<HTML if $doc->{HelpFile};
 	<IMG SRC="Help.png" WIDTH=16 HEIGHT=16
-	 STYLE="cursor:hand" onclick="parent.Libraries.showHelpfile">&nbsp;
+	 STYLE="cursor:hand" onclick="parent.Footer.showHelpfile">&nbsp;
 HTML
     my $type = $icon[$Type[$Type]->[typeATTR]->{typekind}] || '???';
     $html .= "$type <B>$doc->{Name}</B>";
@@ -492,7 +497,7 @@
     } 0..@Member-1;
 
     # Create a table of all members
-    my $html = "<TABLE onhelp=\"parent.Libraries.onHelp('Members')\">\n";
+    my $html = "<TABLE onhelp=\"parent.Footer.onHelp('Members')\">\n";
     foreach (0..@Index-1) {
 	my $id = $Index[$_];
 	my $hidden = $Member[$id]->[membHIDDEN] ? 'Hidden' : '';
@@ -504,9 +509,9 @@
 	}
 	$html .= <<HTML;
 	    <TR><TD NOWRAP ID=MEMBER_$id CLASS=Inactive$hidden
-		    onmouseover="parent.Libraries.rollon('Members')"
-		    onmouseout="parent.Libraries.rolloff('Members')"
-		    onclick="parent.Libraries.selectMember">
+		    onmouseover="parent.Footer.rollon('Members')"
+		    onmouseout="parent.Footer.rolloff('Members')"
+		    onclick="parent.Footer.selectMember">
 		<IMG SRC="$Member[$id]->[membICON].png"
                     WIDTH=16 HEIGHT=16>$default
 		<SPAN $adjust>$Member[$id]->[membDOC]->{Name}</SPAN></TD></TR>
@@ -559,7 +564,7 @@
     my $html = '';
     $html .= <<HTML if $doc->{HelpFile};
 	<IMG SRC="Help.png" WIDTH=16 HEIGHT=16
-	 STYLE="cursor:hand" onclick="parent.Libraries.showHelpfile">
+	 STYLE="cursor:hand" onclick="parent.Footer.showHelpfile">
 HTML
 
     my $type = $Member[$Member]->[membICON];
diff -urN libwin32-0.171/OLE/browser/Browser.html libwin32-0.172/OLE/browser/Browser.html
--- libwin32-0.171/OLE/browser/Browser.html	Mon May 14 00:12:26 2001
+++ libwin32-0.172/OLE/browser/Browser.html	Mon May 14 00:14:16 2001
@@ -4,12 +4,12 @@
 
 <FRAMESET ROWS="120,260,*,92">
     <FRAME NAME="Header">
-    <FRAME NAME="Libraries" SRC="Browser.dhtml" MARGINHEIGHT=0 MARGINWIDTH=8>
+    <FRAME NAME="Libraries" MARGINHEIGHT=0 MARGINWIDTH=8>
     <FRAMESET COLS="240,*">
 	<FRAME NAME="Types" MARGINHEIGHT=0 MARGINWIDTH=8>
 	<FRAME NAME="Members" MARGINHEIGHT=0 MARGINWIDTH=8>
     </FRAMESET>
-    <FRAME NAME="Footer">
+    <FRAME NAME="Footer" SRC="Browser.dhtml">
     <NOFRAMES>
 	<H1>Sorry</H1>
 	<H3>this application only works with Internet Explorer.</H3>
diff -urN libwin32-0.171/OLE/lib/Win32/OLE/Const.pm libwin32-0.172/OLE/lib/Win32/OLE/Const.pm
--- libwin32-0.171/OLE/lib/Win32/OLE/Const.pm	Mon May 14 00:12:26 2001
+++ libwin32-0.172/OLE/lib/Win32/OLE/Const.pm	Mon May 14 00:14:16 2001
@@ -6,7 +6,18 @@
 use Carp;
 use Win32::OLE;
 
-my $Typelibs = __PACKAGE__->_Typelibs();
+my $Typelibs;
+sub _Typelib {
+    my ($clsid,$title,$version,$langid,$filename) = @_;
+    # Filenames might have a resource index appended to it.
+    $filename = $1 if $filename =~ /^(.*\.(?:dll|exe))(\\\d+)$/i;
+    # Ignore if it looks like a file but doesn't exist.
+    # We don't verify existance of monikers or filenames
+    # without a full pathname.
+    return unless -f $filename || $filename !~ /^\w:\\.*\.(exe|dll)$/;
+    push @$Typelibs, \@_;
+}
+__PACKAGE__->_Typelibs;
 
 sub import {
     my ($self,$name,$major,$minor,$language,$codepage) = @_;
diff -urN libwin32-0.171/OLE/lib/Win32/OLE/Lite.pm libwin32-0.172/OLE/lib/Win32/OLE/Lite.pm
--- libwin32-0.171/OLE/lib/Win32/OLE/Lite.pm	Mon May 14 00:12:26 2001
+++ libwin32-0.172/OLE/lib/Win32/OLE/Lite.pm	Mon May 14 00:14:16 2001
@@ -148,12 +148,11 @@
 
 sub AUTOLOAD {
     my $self = shift;
-    $AUTOLOAD =~ s/.*:://o;
-    _croak("Cannot autoload class method \"$AUTOLOAD\"") 
-      unless ref($self) && UNIVERSAL::isa($self, 'Win32::OLE');
+    $AUTOLOAD = substr $AUTOLOAD, rindex($AUTOLOAD, ':')+1;
+    _croak("Cannot autoload class method \"$AUTOLOAD\"")
+	unless ref($self) && UNIVERSAL::isa($self, 'Win32::OLE');
     my $success = $self->Dispatch($AUTOLOAD, my $retval, @_);
     unless (defined $success || ($^H & 0x200) != 0) {
-	warn "retrying default method";
 	# Retry default method if C<no strict 'subs';>
 	$self->Dispatch(undef, $retval, $AUTOLOAD, @_);
     }
diff -urN libwin32-0.171/OLE/lib/Win32/OLE/TPJ.pod libwin32-0.172/OLE/lib/Win32/OLE/TPJ.pod
--- libwin32-0.171/OLE/lib/Win32/OLE/TPJ.pod	Mon May 14 00:12:26 2001
+++ libwin32-0.172/OLE/lib/Win32/OLE/TPJ.pod	Mon May 14 00:14:17 2001
@@ -1,6 +1,10 @@
 =pod
 
-=head1 Win32::OLE
+=head1 NAME
+
+The Perl Journal #10 - Win32::OLE by Jan Dubois
+
+=head1 INTRODUCTION
 
 Suppose you're composing a document with Microsoft Word. You want to
 include an Excel spreadsheet. You could save the spreadsheet in some
diff -urN libwin32-0.171/OLE/lib/Win32/OLE.pm libwin32-0.172/OLE/lib/Win32/OLE.pm
--- libwin32-0.171/OLE/lib/Win32/OLE.pm	Mon May 14 00:13:10 2001
+++ libwin32-0.172/OLE/lib/Win32/OLE.pm	Mon May 14 00:14:16 2001
@@ -6,7 +6,7 @@
 use vars qw($VERSION @ISA @EXPORT @EXPORT_OK @EXPORT_FAIL $AUTOLOAD
 	    $CP $LCID $Warn $LastError $_NewEnum $_Unique);
 
-$VERSION = '0.1401';
+$VERSION = '0.1501';
 
 use Carp;
 use Exporter;
@@ -949,6 +949,6 @@
 
 =head1 VERSION
 
-Version 0.1401	  11 September 2000
+Version 0.1501	  6 February 2001
 
 =cut
diff -urN libwin32-0.171/OLE/t/3_ole.t libwin32-0.172/OLE/t/3_ole.t
--- libwin32-0.171/OLE/t/3_ole.t	Mon May 14 00:13:10 2001
+++ libwin32-0.172/OLE/t/3_ole.t	Mon May 14 00:14:17 2001
@@ -25,7 +25,7 @@
 
 sub AUTOLOAD {
     my $self = shift;
-    $AUTOLOAD =~ s/.*::/SUPER::/;
+    $AUTOLOAD = "SUPER::" . substr $AUTOLOAD, rindex($AUTOLOAD, ':')+1;
     my $retval = $self->$AUTOLOAD(@_);
     return $retval if defined($retval) || $AUTOLOAD eq 'DESTROY';
     printf "# $AUTOLOAD returned OLE error 0x%08x\n", $LastError;
@@ -211,31 +211,48 @@
 print "not " unless $Cell->{Value} == 25;
 printf "ok %d\n", ++$Test;
 
-# 15. Test the valof function
+# 15. Call OLE method with $1 as argument
+
+# This test is commented out because Perl doesn't set POK on $1,
+# it seems to be only pPOK, which still gets translated to undef. :(
+
+#Excel->Option(Warn => 0);
+#$_ = "The formula is MIN(77,33,55)";
+#print "# Expression is \"$1\"\n" if /is (.*)/;
+##$Value = $Sheet->Evaluate("MIN(77,33,55)") if /is (.*)/;
+#$Value = $Sheet->Evaluate($1) if /is (.*)/;
+#Excel->Option(Warn => 2);
+#$Value = "" unless defined $Value;
+#print "# Value is \"$Value\"\n";
+#print "not " unless $Value eq "33";
+
+printf "ok %d\n", ++$Test;
+
+# 16. Test the valof function
 my $RefOf = $Cell;
 my $ValOf = valof $Cell;
 $Cell->{Value} = 27;
 print "not " unless $ValOf == 25 && $RefOf->Value == 27;
 printf "ok %d\n", ++$Test;
 
-# 16. Assign and retrieve a very long string
+# 17. Assign and retrieve a very long string
 $Cell->{Value} = 'a' x 300;
 printf "# Value is %s\n", $Cell->Value;
 print "not " unless $Cell->Value eq ('a' x 300);
 printf "ok %d\n", ++$Test;
 
-# 17. Test 'SetProperty' function
+# 18. Test 'SetProperty' function
 $Cell->SetProperty('Value', 4711);
 printf "# Value is %s\n", $Cell->Value;
 print "not " unless $Cell->Value == 4711;
 printf "ok %d\n", ++$Test;
 
-# 18. The following tests rely on the fact that the font is not yet bold
+# 19. The following tests rely on the fact that the font is not yet bold
 printf "# Bold: %s\n", $Cell->Style->Font->Bold;
 print "not " if $Cell->Style->Font->Bold;
 printf "ok %d\n", ++$Test;
 
-# 19. Assignment by DISPATCH_PROPERTYPUTREF shouldn't work
+# 20. Assignment by DISPATCH_PROPERTYPUTREF shouldn't work
 my $Style = $Book->Styles->Add("MyStyle");
 $Style->Font->{Bold} = 1;
 { local $Excel::Warn = 0; $Cell->{Style} = $Style }
@@ -245,63 +262,63 @@
 print "not " if $LastError != HRESULT(0x80020003) || $Cell->Style->Font->Bold;
 printf "ok %d\n", ++$Test;
 
-# 20. But DISPATCH_PROPERTYPUT should be ok
+# 21. But DISPATCH_PROPERTYPUT should be ok
 $Cell->LetProperty('Style', $Style);
 printf "# Bold: %s\n", $Cell->Style->Font->Bold;
 print "not " unless $Cell->Style->Font->Bold;
 printf "ok %d\n", ++$Test;
 
-# 21. Set a cell range from an array ref containing an IV, PV and NV
+# 22. Set a cell range from an array ref containing an IV, PV and NV
 $Sheet->Range("A8:C9")->{Value} = [[undef, 'Camel'],[42, 'Perl', 3.1415]];
 $Value = $Sheet->Cells(9,2)->Value . $Sheet->Cells(8,2)->Value;
 print "# Value is \"$Value\"\n";
 print "not " unless $Value eq 'PerlCamel';
 printf "ok %d\n", ++$Test;
 
-# 22. Retrieve float value (esp. interesting in foreign locales)
+# 23. Retrieve float value (esp. interesting in foreign locales)
 $Value = $Sheet->Cells(9,3)->{Value};
 print "# Value is \"$Value\"\n";
 print "not " unless $Value == 3.1415;
 printf "ok %d\n", ++$Test;
 
-# 23. Retrieve a 0 dimensional range; check array data structure
+# 24. Retrieve a 0 dimensional range; check array data structure
 $Value = $Sheet->Range("B8")->{Value};
 printf "# Values are: \"%s\"\n", stringify($Value);
 print "not " if ref $Value;
 printf "ok %d\n", ++$Test;
 
-# 24. Retrieve a 1 dimensional row range; check array data structure
+# 25. Retrieve a 1 dimensional row range; check array data structure
 $Value = $Sheet->Range("B8:C8")->{Value};
 printf "# Values are: \"%s\"\n", stringify($Value);
 print "not " unless @$Value == 1 && ref $$Value[0];
 printf "ok %d\n", ++$Test;
 
-# 25. Retrieve a 1 dimensional column range; check array data structure
+# 26. Retrieve a 1 dimensional column range; check array data structure
 $Value = $Sheet->Range("B8:B9")->{Value};
 printf "# Values are: \"%s\"\n", stringify($Value);
 print "not " unless @$Value == 2 && ref $$Value[0] && ref $$Value[1];
 printf "ok %d\n", ++$Test;
 
-# 26. Retrieve a 2 dimensional range; check array data structure
+# 27. Retrieve a 2 dimensional range; check array data structure
 $Value = $Sheet->Range("B8:C9")->{Value};
 printf "# Values are: \"%s\"\n", stringify($Value);
 print "not " unless @$Value == 2 && ref $$Value[0] && ref $$Value[1];
 printf "ok %d\n", ++$Test;
 
-# 27. Check contents of 2 dimensional array
+# 28. Check contents of 2 dimensional array
 $Value = $$Value[0][0] . $$Value[1][0] . $$Value[1][1];
 print "# Value is \"$Value\"\n";
 print "not " unless $Value eq 'CamelPerl3.1415';
 printf "ok %d\n", ++$Test;
 
-# 28. Set a cell formula and retrieve calculated value
+# 29. Set a cell formula and retrieve calculated value
 $Sheet->Cells(3,1)->{Formula} = '=PI()';
 $Value = $Sheet->Cells(3,1)->{Value};
 print "# Value is \"$Value\"\n";
 print "not " unless abs($Value-3.141592) < 0.00001;
 printf "ok %d\n", ++$Test;
 
-# 29. Add single worksheet and check that worksheet count is incremented
+# 30. Add single worksheet and check that worksheet count is incremented
 my $Count = $Sheets->{Count};
 $Book->Worksheets->Add;
 $Value = $Sheets->{Count};
@@ -309,7 +326,7 @@
 print "not " unless $Value == $Count+1;
 printf "ok %d\n", ++$Test;
 
-# 30. Add 2 more sheets, optional arguments are omitted
+# 31. Add 2 more sheets, optional arguments are omitted
 $Count = $Sheets->{Count};
 $Book->Worksheets->Add(undef,undef,2);
 $Value = $Sheets->{Count};
@@ -317,7 +334,7 @@
 print "not " unless $Value == $Count+2;
 printf "ok %d\n", ++$Test;
 
-# 31. Add 3 more sheets before sheet 2 using a named argument
+# 32. Add 3 more sheets before sheet 2 using a named argument
 $Count = $Sheets->{Count};
 $Book->Worksheets(2)->{Name} = 'XYZZY';
 $Sheets->Add($Book->Worksheets(2), {Count => 3});
@@ -326,13 +343,13 @@
 print "not " unless $Value == $Count+3;
 printf "ok %d\n", ++$Test;
 
-# 32. Previous sheet 2 should now be sheet 5
+# 33. Previous sheet 2 should now be sheet 5
 $Value = $Book->Worksheets(5)->{Name};
 print "# Value is \"$Value\"\n";
 print "not " unless $Value eq 'XYZZY';
 printf "ok %d\n", ++$Test;
 
-# 33. Add 2 more sheets at the end using 2 named arguments
+# 34. Add 2 more sheets at the end using 2 named arguments
 $Count = $Sheets->{Count};
 # Following line doesn't work with Excel 7 (Seems like an Excel bug?)
 # $Sheets->Add({Count => 2, After => $Book->Worksheets($Sheets->{Count})});
@@ -340,7 +357,7 @@
 print "not " unless $Sheets->{Count} == $Count+2;
 printf "ok %d\n", ++$Test;
 
-# 34. Number of objects in an enumeration must match its "Count" property
+# 35. Number of objects in an enumeration must match its "Count" property
 my @Sheets = in $Sheets;
 printf "# \$Sheets->{Count} is %d\n", $Sheets->{Count};
 printf "# scalar(\@Sheets) is %d\n", scalar(@Sheets);
@@ -351,7 +368,7 @@
 printf "ok %d\n", ++$Test;
 undef @Sheets;
 
-# 35. Enumerate all application properties using the C<keys> function
+# 36. Enumerate all application properties using the C<keys> function
 my @Properties = keys %$Excel;
 printf "# Number of Excel application properties: %d\n", scalar(@Properties);
 $Value = grep /^(Parent|Xyzzy|Name)$/, @Properties;
@@ -360,7 +377,7 @@
 printf "ok %d\n", ++$Test;
 undef @Properties;
 
-# 36. Translate character from ANSI -> OEM
+# 37. Translate character from ANSI -> OEM
 my ($Version) = $Excel->{Version} =~ /([0-9.]+)/;
 print "# Excel version is $Version\n";
 
@@ -379,15 +396,15 @@
 print "not " unless ord($ANSI) == 163 && ord($OEM) == 156;
 printf "ok %d\n", ++$Test;
 
-# 37. Save workbook to file
+# 38. Save workbook to file
 print "not " unless $Book->SaveAs($File);
 printf "ok %d\n", ++$Test;
 
-# 38. Check if output file exists.
+# 39. Check if output file exists.
 print "not " unless -f $File;
 printf "ok %d\n", ++$Test;
 
-# 39. Access the same file object through a moniker.
+# 40. Access the same file object through a moniker.
 $Obj = Win32::OLE->GetObject($File);
 for ($Count=0 ; $Count < 5 ; ++$Count) {
     my $Type = Win32::OLE->QueryObjectType($Obj);
@@ -402,7 +419,7 @@
 printf "ok %d\n", ++$Test;
 
 
-# 40. Get return value as Win32::OLE::Variant object
+# 41. Get return value as Win32::OLE::Variant object
 $Cell = $Obj->Worksheets('My Sheet #1')->Range('B9');
 my $Variant = Win32::OLE::Variant->new(VT_EMPTY);
 $Cell->Dispatch('Value', $Variant);
@@ -410,7 +427,7 @@
 print "not " unless $Variant->Type == VT_BSTR && $Variant->Value eq 'Perl';
 printf "ok %d\n", ++$Test;
 
-# 41. Use clsid string to start OLE server
+# 42. Use clsid string to start OLE server
 undef $Value;
 eval {
     require Win32::Registry;
@@ -434,7 +451,7 @@
     printf "ok %d\n", $Test;
 }
 
-# 42. Use DCOM syntax to start server (on local machine though)
+# 43. Use DCOM syntax to start server (on local machine though)
 #     This might fail (on Win95/NT3.5 if DCOM support is not installed.
 $Obj = Win32::OLE->new([hostname, 'Excel.Application'], 'Quit');
 $Value = (Win32::OLE->QueryObjectType($Obj))[0];
@@ -442,11 +459,12 @@
 print "not " unless $Value eq 'Excel';
 printf "ok %d\n", ++$Test;
 
-# 43. Find $Excel object via EnumAllObjects()
+# 44. Find $Excel object via EnumAllObjects()
 my $Found = 0;
 $Count = Win32::OLE->EnumAllObjects(sub {
     my $Object = shift;
     my $Class = Win32::OLE->QueryObjectType($Object);
+    $Class = "" unless defined $Class;
     printf "# Object=%s Class=%s\n", $Object, $Class;
     $Found = 1 if $Object == $Excel;
 });
@@ -454,38 +472,38 @@
 print "not " unless $Found;
 printf "ok %d\n", ++$Test;
 
-# 44. _NewEnum should normally be non-browseable
+# 45. _NewEnum should normally be non-browseable
 my $Exists = grep /^_NewEnum$/, keys %{$Excel->Worksheets};
 print "# Exists=$Exists\n";
 print "not " if $Exists;
 printf "ok %d\n", ++$Test;
 
-# 45. make _NewEnum visible
+# 46. make _NewEnum visible
 Excel->Option(_NewEnum => 1);
 $Exists = grep /^_NewEnum$/, keys %{$Excel->Worksheets};
 print "# Exists=$Exists\n";
 print "not " unless $Exists;
 printf "ok %d\n", ++$Test;
 
-# 46. _NewEnum available as a method
+# 47. _NewEnum available as a method
 @Sheets = @{$Excel->Worksheets->_NewEnum};
 print "# $_->{Name}\n" foreach @Sheets;
 print "not " unless @Sheets == 11 && grep $_->Name eq "My Sheet #1", @Sheets;
 printf "ok %d\n", ++$Test;
 
-# 47. _NewEnum available as a property
+# 48. _NewEnum available as a property
 @Sheets = @{$Excel->Worksheets->{_NewEnum}};
 print "not " unless @Sheets == 11 && grep $_->Name eq "My Sheet #1", @Sheets;
 printf "ok %d\n", ++$Test;
 
-# 48. Win32::OLE proxies are non-unique by default
+# 49. Win32::OLE proxies are non-unique by default
 my $Application = $Excel->Application;
 my $Parent = $Excel->Parent;
 printf "# Application=%d Parent=%d\n", $Application, $Parent;
 print "not " if $Application == $Parent;
 printf "ok %d\n", ++$Test;
 
-# 49. Parent and Application property should now return the same object
+# 50. Parent and Application property should now return the same object
 Excel->Option(_Unique => 1);
 $Application = $Excel->Application;
 $Parent = $Excel->Parent;
@@ -493,5 +511,5 @@
 print "not " unless $Application == $Parent;
 printf "ok %d\n", ++$Test;
 
-# 50. Terminate server instance ("ok $Test\n" printed by Excel destructor)
+# 51. Terminate server instance ("ok $Test\n" printed by Excel destructor)
 exit;
diff -urN libwin32-0.171/Process/Changes libwin32-0.172/Process/Changes
--- libwin32-0.171/Process/Changes	Mon May 14 00:12:26 2001
+++ libwin32-0.172/Process/Changes	Mon May 14 00:14:18 2001
@@ -1,8 +1,13 @@
 Revision history for Perl extension Win32::Process.
 
+0.08  Tue Dec 26 2000
+	- make sure the environment is correctly inherited by the new
+	  process.  Only implemented in non-Unicode branch!
+	  (by Jan Dubois <jand@ActiveState.com>)
+
 0.07  Mon May 22 21:45:19 2000
 	- support for passing Unicode strings to methods (thanks to
-	  Doug Lankshear <dougl@activestate.com>)
+	  Doug Lankshear <dougl@ActiveState.com>)
 
 0.06  Sat Sep 25 15:33:29 1999
 	- added GetProcessID() and KillProcess() (suggested by
diff -urN libwin32-0.171/Process/Process.hpp libwin32-0.172/Process/Process.hpp
--- libwin32-0.171/Process/Process.hpp	Mon May 14 00:12:26 2001
+++ libwin32-0.172/Process/Process.hpp	Mon May 14 00:14:18 2001
@@ -21,7 +21,7 @@
 
     BOOL    bRetVal;
     cProcess(char* szAppName, char* szCommLine, BOOL Inherit,
-	      DWORD CreateFlags, char* szCurrDir)
+	      DWORD CreateFlags, void *env, char* szCurrDir)
     {
 	STARTUPINFOA st;
 	PROCESS_INFORMATION	procinfo;
@@ -37,7 +37,7 @@
 	th = NULL;
 
 	bRetVal = CreateProcessA(szAppName,szCommLine,NULL,NULL,
-				 Inherit,CreateFlags,NULL,szCurrDir,
+				 Inherit,CreateFlags,env,szCurrDir,
 				 &st,&procinfo);
 
 	if (bRetVal) {
diff -urN libwin32-0.171/Process/Process.pm libwin32-0.172/Process/Process.pm
--- libwin32-0.171/Process/Process.pm	Mon May 14 00:13:10 2001
+++ libwin32-0.172/Process/Process.pm	Mon May 14 00:14:18 2001
@@ -4,7 +4,7 @@
 require DynaLoader;
 @ISA = qw(Exporter DynaLoader);
 
-$VERSION = '0.07';
+$VERSION = '0.08';
 
 # Items to export into callers namespace by default. Note: do not export
 # names by default without a very good reason. Use EXPORT_OK instead.
diff -urN libwin32-0.171/Process/Process.xs libwin32-0.172/Process/Process.xs
--- libwin32-0.171/Process/Process.xs	Mon May 14 00:12:26 2001
+++ libwin32-0.172/Process/Process.xs	Mon May 14 00:14:18 2001
@@ -15,23 +15,36 @@
 
 #include "../ppport.h"
 
-
 static BOOL
-Create(cProcess* &cP,char* szAppName,char* szCommLine,DWORD Inherit,DWORD CreateFlags,char* szCurrDir)
+Create(cProcess* &cP, char* szAppName, char* szCommLine, DWORD Inherit,
+       DWORD CreateFlags, char* szCurrDir)
 {
+    BOOL bRetVal;
+    void *env = NULL;
+#if PERL_VERSION > 5
+    env = PerlEnv_get_childenv();
+#endif
     cP = NULL;
     try {
-	cP =(cProcess *) new cProcess(szAppName,szCommLine,Inherit,CreateFlags,szCurrDir);
+	cP = (cProcess*)new cProcess(szAppName,szCommLine,Inherit,CreateFlags,
+                                     env,szCurrDir);
+        bRetVal = cP->bRetVal;
     }
     catch (...) {
-	return(FALSE);
+        bRetVal = FALSE;
     }
-    return(cP->bRetVal);
+#if PERL_VERSION > 5
+    PerlEnv_free_childenv(env);
+#endif
+    return bRetVal;
 }
 
 static BOOL
 CreateW(cProcess* &cP,WCHAR* szAppName,WCHAR* szCommLine,DWORD Inherit,DWORD CreateFlags,WCHAR* szCurrDir)
 {
+    // XXX environment will *not* be correctly inherited.
+    // Alas, we don't have corresponding Unicode accessor
+    // functions for the hosts environment.
     cP = NULL;
     try {
 	cP =(cProcess *) new cProcess(szAppName,szCommLine,Inherit,CreateFlags,szCurrDir);
diff -urN libwin32-0.171/Win32.pm libwin32-0.172/Win32.pm
--- libwin32-0.171/Win32.pm	Mon May 14 00:13:10 2001
+++ libwin32-0.172/Win32.pm	Mon May 14 00:14:19 2001
@@ -6,7 +6,7 @@
 #  included with the latest builds of the ActivePerl distribution.)
 #
 
-$VERSION = $VERSION = '0.171';
+$VERSION = $VERSION = '0.172';
 
 require Exporter;
 require DynaLoader;
diff -urN libwin32-0.171/Win32.xs libwin32-0.172/Win32.xs
--- libwin32-0.171/Win32.xs	Mon May 14 00:12:26 2001
+++ libwin32-0.172/Win32.xs	Mon May 14 00:14:20 2001
@@ -1,3 +1,5 @@
+#include <windows.h>
+
 #include "EXTERN.h"
 #include "perl.h"
 #include "XSUB.h"
@@ -431,6 +433,25 @@
     XSRETURN_IV(sysinfo.dwProcessorType);
 }
 
+XS(w32_GuidGen)
+{
+    dXSARGS;
+    GUID guid;
+    char szGUID[50] = {'\0'};
+    HRESULT  hr     = CoCreateGuid(&guid);
+
+    if (SUCCEEDED(hr)) {
+	LPOLESTR pStr = NULL;
+	StringFromCLSID(&guid, &pStr);
+	WideCharToMultiByte(CP_ACP, 0, pStr, wcslen(pStr), szGUID,
+			    sizeof(szGUID), NULL, NULL);
+
+	XSRETURN_PV(szGUID);
+    }
+    else
+	XSRETURN_UNDEF;
+}
+
 XS(boot_Win32)
 {
     dXSARGS;
@@ -449,6 +470,7 @@
     newXS("Win32::UnregisterServer", w32_UnregisterServer, file);
     newXS("Win32::GetArchName", w32_GetArchName, file);
     newXS("Win32::GetChipName", w32_GetChipName, file);
+    newXS("Win32::GuidGen", w32_GuidGen, file);
 
     XSRETURN_YES;
 }
End of Patch.
